﻿'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' 	script: weatherXML_db.vb
' 	Revision 	Date		Programmer	Ccomment
' 	1.0  		11/08/2011	CFGuy		Initial VB.Net Version
' importMCSTemp - inserts the data into the mcsTemp database
' runAccessActionQuery - Runs SQL queries
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Option Strict On
Option Explicit On
Imports VB = Microsoft.VisualBasic
Imports System.IO
Imports System.Data
Imports System.Data.SqlClient
Public Dim debugMode As Boolean = False
Public Dim sINI as String = "weathercom_xml.ini"
Public Dim IName as String = "weatherXML_db"
Function forecastImage(ByVal sFile as String,ByVal bCreate as Boolean)
	Dim pos1 as Integer
	Dim ci as Object
	Dim sReverse, sFileName, sDomain, sSaveTo as String
	Try
		ci = hs.CreateStringClass
			sFile = replace(sFile,"http://","")
			pos1 = inStr(sFile,"/")-1
			sDomain = left(sFile,pos1)
			sFile = replace(sFile,sDomain,"")
			sReverse = ReverseString(sFile)
			pos1 = inStr(sReverse,"/")-1
			sFileName = left(sReverse,pos1)
			sFileName = ReverseString(sFileName)
			if bCreate = True Then
				ci.Add(hs.GetAppPath)
				ci.Add("\html\Images\weather\")
				ci.Add(sFileName)
				sSaveTo = ci.Value
				ci.Reset
				if File.Exists(sSaveTo) Then
					if debugMode = True Then 
						ci.Add("File: ")
						ci.Add(sSaveTo)
						ci.Add(" already exists.  Do not download. ")
						hs.WriteLog(IName,ci.Value)
						ci.Reset
					End if
				Else
					if debugMode = True Then
						ci.Add("Save forecast image to: ")
						ci.Add(sSaveTo)
						hs.WriteLog(IName,ci.Value)
						ci.Reset
					End if
					hs.GetURLImage(sDomain,sFile,True,80,sSaveTo)
				End if
			End if
		ci = Nothing
	Catch e as Exception
		hs.WriteLog(IName,"forecastImage: " & e.Message)
	End Try
	return sFileName
End Function
Sub insertMCSTemp(Optional ByVal sParam as String = "")
	Dim dDay as Date
	Dim x, y, nSt, nEd, nDvCode as Integer
	Dim fs, ss as Object
	Dim sTemp, sIcon, sWindSp, sWindDir, sBarom, sHumid, sReal, sVis, sUpd, sForecast, sImageName, sImagePath as String
	Dim f1Max, f2Max, f3Max, f4Max, f5Max, f1Min, f2Min, f3MIn, f4Min, f5MIn, sDBType, sValue, sDayOfWk, sDevCode as String
	Dim sMCS as String = "mcsTemperature.ini"
	Try
		fs = hs.CreateStringClass
		ss = hs.CreateStringClass
			debugMode = hs.GetINISetting ("Debug","debugMode","False",sINI)
			if debugMode = True Then
				hs.WriteLog(IName,"Start mcsTemperature Insert")
			End if
			sDBType = hs.GetINISetting("dbConnect","dbServer","Access",sINI)
			sValue = hs.GetINISetting("WeatherInfo","CurrentTemp","",sINI)
			sDevCode = hs.GetINISetting("Forecast","ForecastVDCode6","",sMCS) 
			if len(trim(sDevCode)) > 0 Then
				hs.setDeviceString(sDevCode,sValue,True)
			End if
			if isNumeric(sValue) Then
				sValue = sValue * 100
			End if
			sTemp = sValue
			' Condition Icon
			sIcon = hs.GetINISetting("WeatherInfo","ConditionIconName","",sINI) 
			' Wind Spped
			sValue = hs.GetINISetting("WeatherInfo","WindSpeed","",sINI)
			sDevCode = hs.GetINISetting("Forecast","ForecastVDCode0","",sMCS) 
			if len(trim(sDevCode)) > 0 Then
				hs.setDeviceString(sDevCode,sValue,True)
			End if
			if isNumeric(sValue) Then
				sValue = sValue * 100
			End if
			sWindSp = sValue
			' Wind Direction
			sWindDir = hs.GetINISetting("WeatherInfo","WindDirection","",sINI)
			' Barometer
			sValue = hs.GetINISetting("WeatherInfo","Barometer","",sINI)
			sDevCode = hs.GetINISetting("Forecast","ForecastVDCode2","",sMCS) 
			if len(trim(sDevCode)) > 0 Then
				hs.setDeviceString(sDevCode,sValue,True)
			End if
			if isNumeric(sValue) Then
				sValue = sValue * 100
			End if
			sBarom = sValue
			' Humidity
			sValue = hs.GetINISetting("WeatherInfo","Humidity","",sINI)
			sDevCode = hs.GetINISetting("Forecast","ForecastVDCode1","",sMCS) 
			if len(trim(sDevCode)) > 0 Then
				hs.setDeviceString(sDevCode,sValue,True)
			End if
			if isNumeric(sValue) Then
				sValue = sValue * 100
			End if
			sHumid = sValue
			' Feels Like
			sValue = hs.GetINISetting("WeatherInfo","FeelsLike","",sINI)
			sDevCode = hs.GetINISetting("Forecast","ForecastVDCode5","",sMCS) 
			if len(trim(sDevCode)) > 0 Then
				hs.setDeviceString(sDevCode,sValue,True)
			End if
			if isNumeric(sValue) Then
				sValue = sValue * 100
			End if
			sReal = sValue
			' Visibility
			sValue = hs.GetINISetting("WeatherInfo","Visibility","",sINI)
			sDevCode = hs.GetINISetting("Forecast","ForecastVDCode4","",sMCS) 
			if len(trim(sDevCode)) > 0 Then
				hs.setDeviceString(sDevCode,sValue,True)
			End if
			if isNumeric(sValue) Then
				sValue = sValue * 100
			End if
			sVis = sValue
			' Last Updated
			sUpd = hs.GetINISetting("WeatherInfo","LastUpdate","",sINI)
			' Set the forecast field First Day of Week
			if len(trim(hs.GetINISetting("Forecast","DayIcon1","",sINI))) = 0 Then
				nSt = 2
			Else
				nSt = 1
			End if
			nEd = nSt + 4
			For x = nSt to nEd
				ss.Add("DayDate")
				ss.Add(x)
				dDay = hs.GetINISetting("Forecast",ss.Value,"",sINI)
				ss.Reset
				sDayOfWk = dDay.DayOfWeek+1
				fs.Add(sDayOfWk)
				fs.Add("|")
			Next
			fs.Add("|||||")
			For x = nSt to nEd
				ss.Add("DayIcon")
				ss.Add(x)
				sImagePath = hs.GetINISetting("Forecast",ss.Value,"",sINI)
				ss.Reset
				if len(trim(sImagePath)) = 0 Then
					ss.Add("NightIcon")
					ss.Add(x)
					sImagePath = hs.GetINISetting("Forecast",ss.Value,"",sINI)
					ss.Reset
				End if
				sImageName = forecastImage(sImagePath,True)
				fs.Add(sImageName)
				fs.Add("|")
			Next
			sForecast = fs.Value
			fs.Reset
			nDvCode = 7
			y = 1
			' Forecast High Days
			For x = nSt to nEd
				fs.Add("DayHi")
				fs.Add(x)
				sValue = hs.GetINISetting("Forecast",fs.Value,"",sINI)
				fs.Reset
				fs.Add("ForecastVDCode")
				fs.Add(nDvCOde)
				sDevCode = hs.GetINISetting("Forecast",fs.Value,"",sMCS) 
				fs.Reset
				nDvCode = nDvCode+1
				if len(trim(sDevCode)) > 0 Then
					hs.setDeviceString(sDevCode,sValue,True)
				End if
				if isNumeric(sValue) Then
					sValue = sValue * 100
				End if
				if y = 1 Then
					f1Max = sValue
				Elseif y = 2 Then
					f2Max = sValue
				Elseif y = 3 Then
					f3Max = sValue
				Elseif y = 4 Then
					f4Max = sValue
				Elseif y = 5 Then
					f5Max = sValue
				End if
				y = y + 1
			Next			
			' Forecast Low Days
			nDvCode = 12
			y = 1
			For x = nSt to nEd
				fs.Add("DayLow")
				fs.Add(x)
				sValue = hs.GetINISetting("Forecast",fs.Value,"",sINI)
				fs.Reset
				fs.Add("ForecastVDCode")
				fs.Add(nDvCOde)
				sDevCode = hs.GetINISetting("Forecast",fs.Value,"",sMCS) 
				fs.Reset
				nDvCode = nDvCode+1
				if len(trim(sDevCode)) > 0 Then
					hs.setDeviceString(sDevCode,sValue,True)
				End if
				if isNumeric(sValue) Then
					sValue = sValue * 100
				End if
				if y = 1 Then
					f1Min = sValue
				Elseif y = 2 Then
					f2Min = sValue
				Elseif y = 3 Then
					f3Min = sValue
				Elseif y = 4 Then
					f4Min = sValue
				Elseif y = 5 Then
					f5Min = sValue
				End if
				y = y + 1
			Next
			' Build the database query
			fs.Add("INSERT INTO Forecast ([Time], v_Temp, v_CIcon, vWindS, vWindD, vBarometer, vHumidity, v_Real, vVisibility, v_LastUp, ")
			fs.Add("v_Forecast, F1Max, F2Max, F3Max, F4Max, F5Max, F1Min, F2Min, F3Min, F4Min, F5Min) VALUES (")
			if sDBType = "Access" Then
				fs.Add("Now()")
			Elseif sDBType = "SQL Server" THen
				fs.Add("GetDate()")
			End if
			fs.Add(",")
			fs.Add(sTemp)
			fs.Add(",'")
			fs.Add(sIcon)
			fs.Add("',")
			fs.Add(sWindSp)
			fs.Add(",'")
			fs.Add(sWindDir)
			fs.Add("',")
			if len(trim(sBarom)) = 0 Then
				fs.Add("NULL")
			Else
				fs.Add(sBarom)
			End if
			fs.Add(",")
			fs.Add(sHumid)
			fs.Add(",")
			fs.Add(sReal)
			fs.Add(",")
			fs.Add(sVis)
			fs.Add(",")
			if sDBType = "Access" Then
				fs.Add("#")
				fs.Add(sUpd)
				fs.Add("#")
			Elseif sDBType = "SQL Server" THen
				fs.Add("'")
				fs.Add(sUpd)
				fs.Add("'")
			End if
			fs.Add(",")
			if len(trim(sForecast)) = 0 Then
				fs.Add("NULL")
			Else
				fs.Add("'")
				fs.Add(sForecast)
				fs.Add("'")
			End if
			fs.Add(",")
			fs.Add(f1Max)
			fs.Add(",")
			fs.Add(f2Max)
			fs.Add(",")
			fs.Add(f3Max)
			fs.Add(",")
			fs.Add(f4Max)
			fs.Add(",")
			fs.Add(f5Max)
			fs.Add(",")
			fs.Add(f1Min)
			fs.Add(",")
			fs.Add(f2Min)
			fs.Add(",")
			fs.Add(f3Min)
			fs.Add(",")
			fs.Add(f4Min)
			fs.Add(",")
			fs.Add(f5Min)
			fs.Add(") ")
			runAccessActionQuery(fs.Value,"mcs")
		ss = Nothing
		fs = Nothing
	Catch e as Exception
		hs.WriteLog(IName,"insertMCSTemp: " & e.Message)
	End Try
End Sub
Function ReverseString(ByVal InputString As String) As String
	Dim lLen, lCtr as Long
	Dim rs as Object
	Dim sChar as String
	Dim sAns as String
	rs = hs.CreateStringClass
		lLen = Len(InputString)
		For lCtr = lLen To 1 Step -1
			sChar = Mid(InputString, lCtr, 1)
			rs.Add(sChar)
		Next
		Return rs.Value
	rs = Nothing
End Function
Sub runAccessActionQuery(ByVal sSQL as String,Optional ByVal sConnectStr as String = "wX")
	Dim sDSN as String
	if sConnectStr = "mcs" Then
		sDSN = hs.GetINISetting("dbConnect","connectString","Access",sINI)
	Else
		sDSN = hs.GetINISetting("dbConnect","wXML3ConnectString","Access",sINI)
	End if
	debugMode = hs.GetINISetting ("Debug","debugMode","False",sINI)
	if debugMode = true Then
		hs.WriteLog(IName,sSQL)
	End if
	Try
		Dim dbConnection As Data.IDbConnection = New Data.OleDb.OleDbConnection(sDSN)
		dbConnection.Open()
			Dim dbCommand As Data.IDbCommand = New Data.OleDb.OleDbCommand
			dbCommand.CommandText = sSQL
			dbCommand.Connection = dbConnection
 			dbCommand.ExecuteNonQuery()
 		dbConnection.Close()
	Catch e as Exception
		hs.WriteLog("Debug",e.Message)
		hs.WriteLog("runAccessActionQuery",sSQL)
	End Try
End Sub
Sub saveToDatabase(Optional ByVal sParam as String = "")
	Dim fs, ss as Object
	Dim sDBType, sValue as String
	Try
		fs = hs.CreateStringClass
			debugMode = hs.GetINISetting ("Debug","debugMode","False",sINI)
			if debugMode = True Then
				hs.WriteLog(IName,"Insert current information into database.") 
			End if
			sDBType = hs.GetINISetting("dbConnect","wXMLDbServer","Access",sINI)
			fs.Add("INSERT INTO [current] (updatedTime, temperature, feelsLike, todaysHigh, todaysLow, todaysNormalHigh, todaysNormalLow, ")
			fs.Add("todaysRecordHigh, todaysRecordHighYear, todaysRecordLow, todaysRecordLowYear, lastYearsHigh, lastYearsLow, humidity, ")
			fs.Add ("windSpeed, windDirection, windGust, windDegrees, visibility, dewpoint, barometer, barometerdir, moonPhase, weatherSpoken) VALUES (")
			if sDBType = "Access" Then
				fs.Add("#")
				fs.Add(hs.GetINISetting("WeatherInfo","LastUpdate","",sINI))
				fs.Add("#,'")
			Else
				fs.Add("'")
				fs.Add(hs.GetINISetting("WeatherInfo","LastUpdate","",sINI))
				fs.Add("','")
			End if
			fs.Add(hs.GetINISetting("WeatherInfo","CurrentTemp","",sINI))
			fs.Add("','")
			fs.Add(hs.GetINISetting("WeatherInfo","FeelsLike","",sINI))	
			fs.Add("','")
			fs.Add(hs.GetINISetting("HighLowData","High_Temp","",sINI))
			fs.Add("','")
			fs.Add(hs.GetINISetting("HighLowData","Low_Temp","",sINI))
			fs.Add("','")
			fs.Add(hs.GetINISetting("WeatherInfo","TempLastYearHigh","",sINI))
			fs.Add("','")
			fs.Add(hs.GetINISetting("WeatherInfo","TempLastYearLow","",sINI))
			fs.Add("','")
			fs.Add(hs.GetINISetting("WeatherInfo","TempRecordHigh","",sINI))
			fs.Add("','")
			fs.Add(hs.GetINISetting("WeatherInfo","TempRecordHighYear","",sINI))
			fs.Add("','")
			fs.Add(hs.GetINISetting("WeatherInfo","TempRecordLow","",sINI))
			fs.Add("','")
			fs.Add(hs.GetINISetting("WeatherInfo","TempRecordLowYear","",sINI))
			fs.Add("','")
			fs.Add(hs.GetINISetting("WeatherInfo","TempYearAgoHigh","",sINI))
			fs.Add("','")
			fs.Add(hs.GetINISetting("WeatherInfo","TempYearAgoLow","",sINI))
			fs.Add("','")
			fs.Add(hs.GetINISetting("WeatherInfo","Humidity","",sINI))
			fs.Add("','")
			fs.Add(hs.GetINISetting("WeatherInfo","WindSpeed","",sINI))
			fs.Add("','")
			fs.Add(hs.GetINISetting("WeatherInfo","WindDirection","",sINI))
			fs.Add("','")
			fs.Add(hs.GetINISetting("WeatherInfo","Windgust","",sINI))
			fs.Add("','")
			fs.Add(hs.GetINISetting("WeatherInfo","WindDegrees","",sINI))
			fs.Add("','")
			fs.Add(hs.GetINISetting("WeatherInfo","Visibility","",sINI))
			fs.Add("','")
			fs.Add(hs.GetINISetting("WeatherInfo","Dewpoint","",sINI))
			fs.Add("','")
			fs.Add(hs.GetINISetting("WeatherInfo","Barometer","",sINI))
			fs.Add("','")
			fs.Add(hs.GetINISetting("WeatherInfo","BarometerDir","",sINI))
			fs.Add("','")
			fs.Add(hs.GetINISetting("WeatherInfo","moonPhaseTxt","",sINI))
			fs.Add("','")
			fs.Add(replace(hs.GetINISetting("weatherInfo","lastSpoke","",sINI),"'","''"))
			fs.Add("')")
			runAccessActionQuery(fs.Value,"wx")
			fs.Reset
		fs = Nothing
	Catch e as exception
		hs.WriteLog(IName,"saveToDatabase: " & e.Message)
	End Try
End Sub