﻿'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' script: weatherXML_web.vb
' 	Revision 	Date		Programmer	Ccomment
'	1.0  		11/03/2011	CFGuy		Initial VB.Net Version
' checkPageAccess - takes an asp name and looks up the allowed access
' clearDevices - clears all the virtual devices
' getINIValues - used to load the ini values
' pageNoAccess - builds the HTML to display to the user they do not have access to the page
' pageNotActive - builds the HTML to display to the user that the page is not active
' providerlinks - returns the link required to use weather data from certain sources
' setDeviceMap1 - set the device string for Map 1 
' setDeviceMap2 - set the device string for Map 2
' userPermissions - Takes a users login name and checks for admin permissions
' weatherPageLinks - Returns HTML for the Navigation buttons for the weatherXML webpages
' webPageHeader - Returns the alt text for the specified webpage
' winddirImage - Returns the image to match up to the wind direction
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Option Strict On
Option Explicit On
Imports VB = Microsoft.VisualBasic
Imports System.IO
Imports System.Xml 
Imports System.Data
Imports System.Data.SqlClient
Public Dim debugMode As Boolean = False
Public Dim sINI as String = "weathercom_xml.ini"
Public Dim IName as String = "weatherXML_Web"
Public Dim sTableStartCode as String = ""
Public DIm sMapTableStartCode as String = ""
Public Dim sTableMidCode as String = ""
Public Dim sTableEndCode as String = ""
Public Dim UseIcons as Boolean = True
Public Dim useHeadings as Boolean = True
Public Dim useHeadingStyle as String = ""
Public Dim innerHeading as String = ""
Public Dim UseMarquee as Boolean = True
Sub getINIValues()
	Dim fs as Object
	fs = hs.CreateStringClass
		debugMode = hs.GetINISetting ("Debug","debugMode","False",sINI)
		UseIcons = hs.GetINISetting ("Settings","UseIcons","True",sINI)
		useHeadings = hs.GetINISetting ("Settings","useHeadings",true,sINI)
		innerHeading = hs.GetINISetting ("Settings","useHeadingsStyle","",sINI)
		UseMarquee = hs.GetINISetting ("Settings","UseMarquee","0",sINI)
		sTableStartCode = hs.GetINISetting("Settings","TableStartCode","",sINI)
		sMapTableStartCode = hs.GetINISetting("Settings","MapTableStartCode","",sINI)
		sTableMidCode = hs.GetINISetting("Settings","TableMidCode","",sINI)
		sTableEndCode = hs.GetINISetting("Settings","TableEndCode","",sINI)
		fs.Add("<span style=""")
		fs.Add(innerHeading)
		fs.Add(""">")
		useHeadingStyle=fs.Value
	fs = Nothing
End Sub
Function checkPageAccess(ByVal sPageName as String) as String
	Dim x as Integer
	Dim ca as Object
	Dim rtS, sPage as String
	rtS = "none"
	ca = hs.CreateStringClass
		for x = 1 to hs.GetINISetting("webPages","pageNum",1,sINI)
			ca.Add("pageURL")
			ca.Add(x)
			sPage = hs.GetINISetting("webPages",ca.Value,"",sINI)
			ca.Reset			
			if sPage = sPageName Then
				ca.Add("pageLev")
				ca.Add(x)
				rtS = lCase(hs.GetINISetting("webPages",ca.Value,"",sINI))
				ca.Reset
				Exit for
			End if
		Next
	ca = Nothing
	Return rtS
End Function
Function chkPlugins(sPluginName)
	Dim objPlugin, plug as Object
	objPlugin = hs.GetPluginsEx
	if Not objPlugin Is Nothing Then
		For Each plug In objPlugin
			Try
				If lCase(plug.name) = lCase(sPluginName) Then
					Return True
					Exit Function
				End if
			Catch e as Exception
				Continue For
			End Try
		Next
	End if
	Return False
End Function
Sub clearDevices(ByVal sParm as Object)
	Dim devCode as String
	devCode = hs.GetINISetting ("Settings","devUpdated","",sINI)
	hs.SetDeviceString(devCode,"",True)
	devCode = hs.GetINISetting ("Settings","devCondition","",sINI)
	hs.SetDeviceString(devCode,"",True)
	devCode = hs.GetINISetting ("Settings","devTemp","",sINI)
	hs.SetDeviceString(devCode,"",True)
	devCode = (hs.GetINISetting ("Settings","devFeelsLike","",sINI))
	hs.SetDeviceString(devCode,"",True)
	devCode = hs.GetINISetting ("Settings","devHiTemp","",sINI)
	hs.SetDeviceString(devCode,"",True)
	devCode = hs.GetINISetting ("Settings","devLowTemp","",sINI)
	hs.SetDeviceString(devCode,"",True)
	devCode = hs.GetINISetting ("Settings","devTempHistory","",sINI)
	hs.SetDeviceString(devCode,"",True)
	devCode = hs.GetINISetting ("Settings","devTempHistoryLow","",sINI)
	hs.SetDeviceString(devCode,"",True)
	devCode = hs.GetINISetting ("Settings","devTempRecordHigh","",sINI)
	hs.SetDeviceString(devCode,"",True)
	devCode = hs.GetINISetting ("Settings","devTempRecordLow","",sINI)
	hs.SetDeviceString(devCode,"",True)
	devCode = hs.GetINISetting ("Settings","devHumidity","",sINI)
	hs.SetDeviceString(devCode,"",True)
	devCode = hs.GetINISetting ("Settings","devWindDir","",sINI)
	hs.SetDeviceString(devCode,"",True)
	devCode = hs.GetINISetting ("Settings","devWindDegrees","",sINI)
	hs.SetDeviceString(devCode,"",True)
	devCode = hs.GetINISetting ("Settings","devWindGust","",sINI)
	hs.SetDeviceString(devCode,"",True)
	devCode = hs.GetINISetting ("Settings","devWind","",sINI)
	hs.SetDeviceString(devCode,"",True)
	devCode = hs.GetINISetting ("Settings","devVisibility","",sINI)
	hs.SetDeviceString(devCode,"",True)
	devCode = hs.GetINISetting ("Settings","devDewpoint","",sINI)
	hs.SetDeviceString(devCode,"",True)
	devCode = hs.GetINISetting ("Settings","devBarometer","",sINI)
	hs.SetDeviceString(devCode,"",True)
	devCode = hs.GetINISetting ("Settings","devBarometerDir","",sINI)
	hs.SetDeviceString(devCode,"",True)
	devCode = hs.GetINISetting ("Settings","devMap1","",sINI)
	hs.SetDeviceString(devCode,"",True)
	devCode = hs.GetINISetting ("Settings","devMap2","",sINI)
	hs.SetDeviceString(devCode,"",True)
 	devCode = hs.GetINISetting("Settings","lastSpoken","",sINI)
	hs.SetDeviceString(devCode,"",True)
	devCode = hs.GetINISetting ("Settings","devForecast","",sINI)
	hs.SetDeviceString(devCode,"",True)
	devCode=hs.GetINISetting("Settings","forecastToday","",sINI)
	hs.SetDeviceString(devCode,"",True)
	devCode = hs.GetINISetting ("Settings","forecastTonight","",sINI)
	hs.SetDeviceString(devCode,"",True)
	devCode = hs.GetINISetting ("Settings","forecastTomorrow","",sINI)
	hs.SetDeviceString(devCode,"",True)
	devCode = hs.GetINISetting ("Settings","forecastTomorrowNight","",sINI)
	hs.SetDeviceString(devCode,"",True)
	devCode = hs.GetINISetting ("Settings","forecast2Day","",sINI)
	hs.SetDeviceString(devCode,"",True)
	devCode = hs.GetINISetting ("Settings","forecast3Day","",sINI)
	hs.SetDeviceString(devCode,"",True)
	devCode = hs.GetINISetting ("Settings","forecast4Day","",sINI)
	hs.SetDeviceString(devCode,"",True)
	devCode = hs.GetINISetting ("Settings","forecast5Day","",sINI)
	hs.SetDeviceString(devCode,"",True)
	devCode = hs.GetINISetting ("Settings","forecast6Day","",sINI)
	hs.SetDeviceString(devCode,"",True)
	devCode = hs.GetINISetting ("Settings","forecast7Day","",sINI)
	hs.SetDeviceString(devCode,"",True)
End Sub
Function pageNoAccess(Optional ByVal sName as String = "") as String
	Dim na as Object
	Dim rtS as String
	na = hs.CreateStringClass
		na.Add("<table border=""0"" cellpadding=""0"" cellspacing=""1"">")
		na.Add("<tr><td class=""pagetitle""><span style=""display='';"" id=""pgtitle"">Page Access</span></td></tr>")
		na.Add("<tr><td class=""tablecolumn"">You do not have access to this page.</td></tr></table>")
		rtS = na.Value
	na = Nothing
	Return rtS
End Function
Function pageNotActive(Optional ByVal sName as String = "") as String
	Dim na as Object
	Dim rtS as String
	na = hs.CreateStringClass
		na.Add("<table border=""0"" cellpadding=""0"" cellspacing=""1"">")
		na.Add("<tr><td class=""pagetitle""><span style=""display='';"" id=""pgtitle"">Page Access</span></td></tr>")
		na.Add("<tr><td class=""tablecolumn"">This page is not active.</td></tr></table>")
		rtS = na.Value
	na = Nothing
	Return rtS
End Function
Function providerLinks(Optional ByVal sParam as String = "") as String
	Dim sLink as String = ""
	if hs.GetINISetting("Settings","xmlSource","",sINI) = "wwo" Then
		sLink = "<br/>Powered by <a href=""http://www.worldweatheronline.com/"" title=""Free local weather content provider"" target=""_blank"">World Weather Online</a>"
	Elseif hs.GetINISetting("Settings","xmlSource","",sINI) = "wu" Then
		sLink = "<br/>Weather provided by <a href=""http://www.wunderground.com/"" title=""Free local weather content provider"" target=""_blank"">Weather Underground</a>"
	End if
	Return sLink
End Function
Sub setDeviceMap1(Optional ByVal sParm as String = "")
	Dim fs as Object
	Dim devMap1, imageURL, imageCap, imageLeg, mapImage as String
	getINIValues()
	mapImage = hs.GetINISetting ("Settings","TouchpadImage","",sINI)
	devMap1 = hs.GetINISetting ("Settings","devMap1","",sINI)
	if len(trim(devMap1)) > 0 Then
		fs = hs.CreateStringClass
			if IsNumeric(mapImage) Then
				fs.Add("image")
				fs.Add(mapImage)
				imageURL = hs.GetINISetting ("Maps",fs.Value,"",sINI)
				fs.Reset
				if len(trim(imageURL)) > 0 Then
					fs.Add("image")
					fs.Add(mapImage)
					fs.Add("caption")
					imageCap = hs.GetINISetting ("Maps",fs.Value,"",sINI)
					fs.Reset
					fs.Add("image")
					fs.Add(mapImage)
					fs.Add("legend")
					imageLeg = hs.GetINISetting ("Maps",fs.Value,"",sINI)
					fs.Reset
					fs.Add(sMapTableStartCode)
					fs.Add(imageCap)
					fs.Add("<br/><a href='#' onClick=""window.open('")
					fs.Add(imageURL)
					fs.Add("','newWnd','width=720,height=486,toolbar=1,status=0,scrollbars=1,resizable=1')""><img src='")
					fs.Add(imageURL)
					fs.Add("'width='294' height='201' align='middle'></center>")
					fs.Add("</center>")
					fs.Add(sTableEndCode)
				Else
					fs.Add("<span style=""color=red;"">No map URL has been provided.  Please setup the map on the Weather Admin page.</span>")
				End if
				hs.SetDeviceString(devMap1,fs.Value,True)
				fs.Reset
			End if
		fs = Nothing
	End if
End Sub
Sub setDeviceMap2(Optional ByVal sParm as String = "")
	Dim fs as Object
	Dim devMap2, imageURL, imageCap, mapImage as String
	getINIValues()
	mapImage = hs.GetINISetting ("Settings","TouchpadImage2","",sINI)
	devMap2 = hs.GetINISetting ("Settings","devMap2","",sINI)
	if len(trim(devMap2)) > 0 Then
		fs = hs.CreateStringClass
			if IsNumeric(mapImage) Then
				fs.Add("image")
				fs.Add(mapImage)
				imageURL = hs.GetINISetting ("Maps",fs.Value,"",sINI)
				fs.Reset
				if len(trim(imageURL)) > 0 Then
					fs.Add("image")
					fs.Add(mapImage)
					fs.Add("caption")
					imageCap = hs.GetINISetting ("Maps",fs.Value,"",sINI)
					fs.Reset
					fs.Add(sMapTableStartCode)
					fs.Add(imageCap)
					fs.Add("<br/><a href='#' onClick=""window.open('")
					fs.Add(imageURL)
					fs.Add("','newWnd','width=720,height=486,toolbar=1,status=0,scrollbars=1,resizable=1')""><img src='")
					fs.Add(imageURL)
					fs.Add("'width='294' height='201' align='middle'>")
					fs.Add("<br/><font color=""#FFFFFF""> Klik voor een grotere kaart</font>")
					fs.Add(sTableEndCode)
				Else
					fs.Add("<span style=""color=red;"">No map URL has been provided.  Please setup the map on the Weather Admin page.</span>")
				End if
				hs.SetDeviceString(devMap2,fs.Value,True)
				fs.Reset
			End if
		fs = Nothing
	End if
End Sub
Function userPermissions(ByVal sChkUser as String)
	Dim arrUsers, arrPrivs as Array
	Dim x, nAdmin, nPriv as Integer
	Dim sAllUsers, sUser as String
	sAllUsers = hs.GetUsers
	arrUsers = Split(sAllUsers, ",")
	nAdmin=0
	For x = 0 To UBound(arrUsers)
		arrPrivs = Split(arrUsers(x),"|")
		sUser = arrPrivs(0)
		nPriv = arrPrivs(1)
		if lCase(sUser) = lCase(sChkUser) Then
			if nPriv AND 2 Then
				nAdmin=1
				Exit for
			End if
		End if
	Next
	Return nAdmin
End Function
Function weatherPageLinks(ByVal sChkUser as String)
	Dim aSortA as Array
	Dim aSortB(0) 
	Dim aSort
	Dim x, y, nPriv, nLoop as Integer
	Dim fs, ss as Object
	Dim sURL, sBtn, sAlt, sLev, rtS, sSortOrder as String
	nPriv = userPermissions(sChkUser)
	if hs.GetINISetting("Settings","showMenu","0",sINI) = "1" Then
		fs = hs.CreateStringClass
			ss = hs.CreateStringClass
				fs.Add("<br/>")
				sSortOrder = hs.GetINISetting("webPages","pageSort","",sINI)
				if len(trim(sSortOrder)) > 0 Then
					aSortA = split(sSortOrder,",")
					aSort = aSortA
				Else
					nLoop = hs.GetINISetting("webPages","pageNum",6,sINI)-1
					ReDim aSortB(nLoop)
					for x = 0 to nLoop
						aSortB(x) = x+1
					Next
					aSort = aSortB
				End if
				for x = 0 to uBound(aSort)
					y = aSort(x)
					ss.Add("pageURL")
					ss.Add(y)
					sURL = hs.GetINISetting("webPages",ss.Value,"",sINI)
					ss.Reset
					ss.Add("pageBtn")
					ss.Add(y)
					sBtn = hs.GetINISetting("webPages",ss.Value,"",sINI)
					ss.Reset
					ss.Add("pageAlt")
					ss.Add(y)
					sAlt = hs.GetINISetting("webPages",ss.Value,"",sINI)
					ss.Reset
					ss.Add("pageLev")
					ss.Add(y)
					sLev = hs.GetINISetting("webPages",ss.Value,"",sINI)
					ss.Reset
					if (lCase(sLev)) <> "none" AND len(Trim(sURL)) > 0 Then
						if (lCase(sLev) <> "admin") OR (nPriv = 1) Then
							if len(trim(sURL)) > 0 Then
								fs.Add("<input type=""button"" class=""functionrowbutton"" value=""")
								fs.Add(sBtn)
								fs.Add(""" alt=""")
								fs.Add(sAlt)
								fs.Add(""" onClick=""location.href='/weathercom_xml/")
								fs.Add(sURL)
								fs.Add("'"" onmouseover=""this.className='functionrowbuttonselected';"" onmouseout=""this.className='functionrowbutton';"">")
							End if
						End if
					End if
				Next
				fs.Add("<br/>")
				rtS = fs.Value
			ss = Nothing
		fs = Nothing
	End if
	Return rtS
End Function
Function webPageHeader(ByVal sChkLink as String)
	Dim aSort
	Dim x, nLoop as Integer
	Dim wp as Object
	Dim sLink, sTitle as String
	wp = hs.CreateStringClass
		if len(Trim(hs.GetINISetting("webPages","pageSort","",sINI))) > 0 Then
			aSort = split(hs.GetINISetting("webPages","pageSort","",sINI),",")
			nLoop = uBound(aSort) +1
		Else
			nLoop = hs.GetINISetting("webPages","pageNum",1,sINI)
		End if
		for x = 1 to nLoop
			wp.Add("pageURL")
			wp.Add(x)
			sLink = hs.GetINISetting("webPages",wp.Value,"",sINI)
			wp.Reset
			if trim(sLink) = trim(sChkLink) Then
				wp.Add("pageAlt")
				wp.Add(x)
				sTitle = hs.GetINISetting("webPages",wp.Value,"",sINI)
				Exit For
			End if
		Next
	wp = Nothing
	Return sTitle
End function
Function windDirImage(ByVal sDir as String)
	Dim sImg as String = ""
	Select Case lCase(sDir)
	Case "calm"
	    sImg = "calm"
        Case "east"
            sImg = "e"
        Case "east northeast"
            sImg = "ENE"
        Case "east southeast"
            sImg = "ese"
	Case "north"
	    sImg = "n"
        Case "northeast"
            sImg = "ne"
        Case "north northeast"
            sImg = "nne"
        Case "north northwest"
            sImg = "nnw"
        Case "northwest"
            sImg = "nw"
        Case "south"
            sImg = "s"
        Case "southeast"
            sImg = "se"
        Case "south southeast"
            sImg = "sse"
        Case "south southwest"
            sImg = "ssw"
        Case "southwest"
            sImg = "sw"
        Case "west"
            sImg = "w"
        Case "west northwest"
            sImg = "wnw"
        Case "west southwest"
            sImg = "wsw"
        Case Else
            sImg = sDir
	End Select
	Return sImg
End Function
