﻿'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' script: weatherXML_wu.vb
' 	Revision 	Date		Programmer	Ccomment
'	1.0  		11/03/2011	CFGuy		Initial VB.Net Version
' clearINIData - clears the forecast ini values
' clearOldINIData - clears the extended forecast ini values
' getINIValues - used to load the ini values
' importAlmanac - import the temperature history from weather underground
' importAstronomy - import the moon phase
' importForecast - import the forecast
' importForecaseHourly - import the hourly forecast
' importHourly - public function to allow triggering the hourly forecast seperate from the normal import
' ReverseString - takes a string and reverses it
' setDeviceForecastClear - clers the forecast device strings before changing with new data
' setDeviceMoonPhase - set the device string for the moon phase
' setDeviceTempHistHigh - set the device string for the todays normal high
' setDeviceTempHistLow - set the device string for the todays normal low
' setDeviceTempRecordHigh - set the device string for the todays record high
' setDeviceTempRecordLow - set the device string for the todays record low
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Option Strict On
Option Explicit On
Imports VB = Microsoft.VisualBasic
Imports System.IO
Imports System.Xml 
Public Dim debugMode As Boolean = False
Public Dim sINI as String = "weathercom_xml.ini"
Public Dim sINI2 as String = "\..\data\weathercom_xml\weatherHourly.dat"
Public Dim IName as String = "weatherXML_WU"
Public Dim sTableStartCode as String = ""
Public DIm sMapTableStartCode as String = ""
Public Dim sTableMidCode as String = ""
Public Dim sTableEndCode as String = ""
Public Dim UseIcons as Boolean = True
Public Dim useHeadings as Boolean = True
Public Dim useHeadingStyle as String = ""
Public Dim innerHeading as String = ""
Public Dim UseMarquee as Boolean = True
Sub getINIValues(Optional ByVal sParam as String = "")
	Dim fs as Object
	fs = hs.CreateStringClass
		debugMode = hs.GetINISetting ("Debug","debugMode","False",sINI)
		UseIcons = hs.GetINISetting ("Settings","UseIcons","True",sINI)
		useHeadings = hs.GetINISetting ("Settings","useHeadings",true,sINI)
		innerHeading = hs.GetINISetting ("Settings","useHeadingsStyle","",sINI)
		UseMarquee = hs.GetINISetting ("Settings","UseMarquee","0",sINI)
		sTableStartCode = hs.GetINISetting("Settings","TableStartCode","",sINI)
		sMapTableStartCode = hs.GetINISetting("Settings","MapTableStartCode","",sINI)
		sTableMidCode = hs.GetINISetting("Settings","TableMidCode","",sINI)
		sTableEndCode = hs.GetINISetting("Settings","TableEndCode","",sINI)
		fs.Add("<span style=""")
		fs.Add(innerHeading)
		fs.Add(""">")
		useHeadingStyle=fs.Value
	fs = Nothing
End Sub

Function buildForecast(ByVal sDay as String,ByVal sDate as String,ByVal sCond as String,ByVal sHi as String,ByVal sLow as String,ByVal sPrecip as String)
	Dim fs as Object
	Dim rtS as String
	fs = hs.CreateStringClass
		fs.Add("Vooruitzicht voor ")
		fs.Add(sDay)
		fs.Add(", ")
		fs.Add(hs.RunEx("AZ_weathercom_xml_speak.vb","dayString",sDate,True))
		fs.Add(".  ")
		fs.Add(sCond)
		fs.Add(".  De hoogste temperatuur wordt ")
		if cSng(sHi) < -9 OR cSng(sHi) > 9 Then
			fs.Add ("in de ")
		End if
		fs.Add(hs.RunEx("AZ_weathercom_xml_speak.vb","tempAveString",sHi,True))
		if len(trim(sLow)) > 0 Then
			fs.Add(" en de laagste ")
			if cSng(sLow) < -9 OR cSng(sLow) > 9 Then
				fs.Add ("in de ")
			End if
			fs.Add(hs.RunEx("AZ_weathercom_xml_speak.vb","tempAveString",sLow,True))
		End if
		fs.Add(".  ")
		if len(trim(sPrecip)) > 0 Then
			if isNumeric(sPrecip) Then
				if sPrecip > 0 Then
					fs.Add("Er is een kans op neerslag: ")
					fs.Add(sPrecip)
					fs.Add(" ")
					fs.Add(hs.GetINISetting ("InfoUnit","Rain","%",sINI))
				End if
			End if
		End if
		rtS = fs.Value
	fs = Nothing	
	return rtS
End Function

Sub clearINIData(ByVal howMany as Integer)
	Dim x as Integer
	Dim cd as Object
	Try
		cd = hs.CreateStringClass
			For x = 1 to howMany
				cd.Add("DayDate")
				cd.Add(x)
				if len(hs.GetINISetting("Forecast",cd.Value,"",sINI)) > 0 Then
					hs.SaveINISetting("Forecast",cd.Value,"",sINI)
				End if
				cd.Reset
				cd.Add("DayName")
				cd.Add(x)
				if len(hs.GetINISetting("Forecast",cd.Value,"",sINI)) > 0 Then
					hs.SaveINISetting("Forecast",cd.Value,"",sINI)
				End if
				cd.Reset
				cd.Add("DayHi")
				cd.Add(x)
				if len(hs.GetINISetting("Forecast",cd.Value,"",sINI)) > 0 Then
					hs.SaveINISetting("Forecast",cd.Value,"",sINI)
				End if
				cd.Reset
				cd.Add("DayLow")
				cd.Add(x)
				if len(hs.GetINISetting("Forecast",cd.Value,"",sINI)) > 0 Then
					hs.SaveINISetting("Forecast",cd.Value,"",sINI)
				End if
				cd.Reset
				cd.Add("DayIcon")
				cd.Add(x)
				if len(hs.GetINISetting("Forecast",cd.Value,"",sINI)) > 0 Then
					hs.SaveINISetting("Forecast",cd.Value,"",sINI)
				End if
				cd.Reset
				cd.Add("DayIconName")
				cd.Add(x)
				if len(hs.GetINISetting("Forecast",cd.Value,"",sINI)) > 0 Then
					hs.SaveINISetting("Forecast",cd.Value,"",sINI)
				End if
				cd.Reset
				cd.Add("DayCondition")
				cd.Add(x)
				if len(hs.GetINISetting("Forecast",cd.Value,"",sINI)) > 0 Then
					hs.SaveINISetting("Forecast",cd.Value,"",sINI)
				End if
				cd.Reset
				cd.Add("DayPrecipitation")
				cd.Add(x)
				if len(hs.GetINISetting("Forecast",cd.Value,"",sINI)) > 0 Then
					hs.SaveINISetting("Forecast",cd.Value,"",sINI)
				End if
				cd.Reset
				cd.Add("DayForecast")
				cd.Add(x)
				if len(hs.GetINISetting("Forecast",cd.Value,"",sINI)) > 0 Then
					hs.SaveINISetting("Forecast",cd.Value,"",sINI)
				End if
				cd.Reset
				cd.Add("windSpeed")
				cd.Add(x)
				if len(hs.GetINISetting("Forecast",cd.Value,"",sINI)) > 0 Then
					hs.SaveINISetting("Forecast",cd.Value,"",sINI)
				End if
				cd.Reset
				cd.Add("windDir")
				cd.Add(x)
				if len(hs.GetINISetting("Forecast",cd.Value,"",sINI)) > 0 Then
					hs.SaveINISetting("Forecast",cd.Value,"",sINI)
				End if
				cd.Reset
				cd.Add("NightIcon")
				cd.Add(x)
				if len(hs.GetINISetting("Forecast",cd.Value,"",sINI)) > 0 Then
					hs.SaveINISetting("Forecast",cd.Value,"",sINI)
				End if
				cd.Reset
				cd.Add("NightIconName")
				cd.Add(x)
				if len(hs.GetINISetting("Forecast",cd.Value,"",sINI)) > 0 Then
					hs.SaveINISetting("Forecast",cd.Value,"",sINI)
				End if
				cd.Reset
				cd.Add("NightCondition")
				cd.Add(x)
				if len(hs.GetINISetting("Forecast",cd.Value,"",sINI)) > 0 Then
					hs.SaveINISetting("Forecast",cd.Value,"",sINI)
				End if
				cd.Reset
				cd.Add("NightPrecipitation")
				cd.Add(x)
				if len(hs.GetINISetting("Forecast",cd.Value,"",sINI)) > 0 Then
					hs.SaveINISetting("Forecast",cd.Value,"",sINI)
				End if
				cd.Reset
				cd.Add("NightForecast")
				cd.Add(x)
				if len(hs.GetINISetting("Forecast",cd.Value,"",sINI)) > 0 Then
					hs.SaveINISetting("Forecast",cd.Value,"",sINI)
				End if
				cd.Reset
			Next
		cd = Nothing
	Catch e as Exception
		hs.Writelog(IName,"clearINIData " & e.Message)
	End Try
End Sub

Function clearOldINIData(ByVal howMany as Integer)
	Dim x as Integer
	Dim cd as Object
	Try
		cd = hs.CreateStringClass
			For x = 1 to howMany
				cd.Add("ExtForecast")
				cd.Add(x)
				if len(hs.GetINISetting("WeatherCom_ExtForecast",cd.Value,"",sINI)) > 0 Then
					hs.SaveINISetting("WeatherCom_ExtForecast",cd.Value,"",sINI)
				End if
				cd.Reset
			Next 
		cd = Nothing
	Catch e as Exception
		hs.Writelog(IName,"clearOldINIData " & e.Message)
	End Try
	Return "done"
End Function

Sub importAlmanac(ByVal strXMLFile as String)
	Dim dRun as Date
	Dim x as Integer
	Dim fs, FSO, xmlfile, oNodeList, oNode, xNode as Object
	Dim unitTemp, sValue, sValue2, sYear as String
	Try
		getINIValues()
		fs = hs.CreateStringClass
			unitTemp = hs.GetINISetting("InfoUnit","Temperature","F",sINI)
			' Start the import from the file
			xmlfile = CreateObject("Microsoft.XMLDOM")
				xmlfile.async=false
				xmlfile.load(strXMLFile)
				hs.SaveINISetting("Debug","ErrorCodeAlmanac",xmlfile.parseError.errorcode,sINI)
				if xmlfile.parseError.errorcode <> 0 Then
					fs.Add("There was an error with the XML file.  Error Reason: ")
					fs.Add(xmlfile.parseError.reason)
					hs.WriteLog(IName,fs.Value)
					fs.Reset
					dRun = dRun.addMinutes(-30)
					hs.SaveINISetting("Settings","lastranWUAl",dRun,sINI)
					hs.SaveINISetting("Debug","ErrorReasonAlmanac",xmlfile.parseError.reason,sINI)
					hs.SaveINISetting("Debug","ErrorTimeAlmanac",trim(Now()),sINI)
				End if
				if xmlfile.parseError.errorcode = 0 Then
					oNodeList = xmlfile.selectNodes("response/almanac/temp_high")
						oNode = oNodeList.nextNode
							if unitTemp = "F" Then
								xNode = oNode.selectSingleNode("normal").selectSingleNode("F")
							Else
								xNode = oNode.selectSingleNode("normal").selectSingleNode("C")
							End if
							if NOT xNode Is Nothing Then
								if unitTemp = "F" Then
									sValue = oNode.selectSingleNode("normal").selectSingleNode("F").text
									sValue2 = oNode.selectSingleNode("record").selectSingleNode("F").text
								Else
									sValue = oNode.selectSingleNode("normal").selectSingleNode("C").text
									sValue2 = oNode.selectSingleNode("record").selectSingleNode("C").text
								End if
								sYear = oNode.selectSingleNode("recordyear").text
								if debugMode = True Then
									hs.WriteLog(IName,"De maximum temperatuur van vandaag: " & sValue)
									hs.WriteLog(IName,"De hoogste temperatuur vandaag: " & sValue2)
									hs.WriteLog(IName,"De hoogste temperatuur ooit op deze dag was in " & sYear)
								End if
								setDeviceTempHistHigh(sValue)
								setDeviceTempRecordHigh(sValue2,sYear)
							End if
					oNodeList = Nothing
					oNodeList = xmlfile.selectNodes("response/almanac/temp_low")
						oNode = oNodeList.nextNode
							if unitTemp = "F" Then
								xNode = oNode.selectSingleNode("normal").selectSingleNode("F")
							Else
								xNode = oNode.selectSingleNode("normal").selectSingleNode("C")
							End if
							if NOT xNode Is Nothing Then
								if unitTemp = "F" Then
									sValue = oNode.selectSingleNode("normal").selectSingleNode("F").text
									sValue2 = oNode.selectSingleNode("record").selectSingleNode("F").text
								Else
									sValue = oNode.selectSingleNode("normal").selectSingleNode("C").text
									sValue2 = oNode.selectSingleNode("record").selectSingleNode("C").text
								End if
								sYear = oNode.selectSingleNode("recordyear").text
								if debugMode = True Then
									hs.WriteLog(IName,"De minimum temperatuur van vandaag: " & sValue)
									hs.WriteLog(IName,"De laagste temperatuur vandaag: " & sValue2)
									hs.WriteLog(IName,"De laagste temperatuur ooit op deze dag was in " & sYear)
								End if
								setDeviceTempHistLow(sValue)
								setDeviceTempRecordLow(sValue2,sYear)
							End if
					oNodeList = Nothing
					if debugMode =  true Then
						hs.WriteLog(IName,"Finished importing weather underground almanac.")
					End if
				End if
			xmlfile = Nothing
		fs = Nothing
	Catch e as Exception
		hs.WriteLog(IName,"importAlmanac: " & e.message)
	End Try
End Sub

Sub importAstronomy(ByVal strXMLFile as String)
	Dim dRun as Date
	Dim fs, FSO, xmlfile, oNodeList, oNode as Object
	Dim sValue, sDay as String
	Try
		getINIValues()
		fs = hs.CreateStringClass
			' Start the import from the file
			xmlfile = CreateObject("Microsoft.XMLDOM")
				xmlfile.async=false
				xmlfile.load(strXMLFile)
				hs.SaveINISetting("Debug","ErrorCodeAstronomy",xmlfile.parseError.errorcode,sINI)
				if xmlfile.parseError.errorcode <> 0 Then
					fs.Add("There was an error with the XML file.  Error Reason: ")
					fs.Add(xmlfile.parseError.reason)
					hs.WriteLog(IName,fs.Value)
					fs.Reset
					dRun = dRun.addMinutes(-30)
					hs.SaveINISetting("Settings","lastranWUA",dRun,sINI)
					hs.SaveINISetting("Debug","ErrorReasonAstronomy",xmlfile.parseError.reason,sINI)
					hs.SaveINISetting("Debug","ErrorTimeAstronomy",trim(Now()),sINI)
				End if
				if xmlfile.parseError.errorcode = 0 Then
					oNodeList = xmlfile.selectNodes("response/moon_phase")
					if Not oNodeList Is Nothing THen
						oNode = oNodeList.nextNode
						if Not oNode Is Nothing Then
							sDay = oNode.selectSingleNode("ageOfMoon").text
							sValue = oNode.selectSingleNode("percentIlluminated").text
							fs.Add("procent")
							fs.Add(sDay)
							hs.SaveINISetting("Moon",fs.Value,sValue,sINI)
							fs.Reset
							setDeviceMoonPhase(sDay,sValue)
						End if
					End if
					oNodeList = Nothing
					if debugMode = true Then
						hs.WriteLog(IName,"Finished importing weather underground astronomy.")
					End if
				End if
			xmlfile = Nothing
		fs = Nothing
	Catch e as Exception
		hs.WriteLog(IName,"importAstronomy: " & e.message)
	End Try
End Sub

Sub importForecast(ByVal strXMLFile as String)
	Dim bChk as Boolean = False
	Dim bWd, bRh as Boolean
	Dim dRun as Date = Now()
	Dim x as Integer
	Dim fs, ss, FSO, xmlfile, oNodeList, oNode, xNode, xNode2 as Object
	Dim curTemp, cBar, wcTemp, wcWind, wcHum as Single
	Dim unitTemp, innerHeading, sValue, sValue2, sYear, sWhereFrom, sWindDir, windDirImage as String
	Dim feelLike, sImage, dTime, dChk, sKey, sNext, sPeriod, fDev, fNext, sMarS, sMarE as String
	Dim sCond, sHi, sLow, sPrecip, sDay, sDate, sIconName as String
	Try
		getINIValues()
		fs = hs.CreateStringClass
		ss = hs.CreateStringClass
			unitTemp = hs.GetINISetting("InfoUnit","Temperature","F",sINI)
			sWhereFrom = hs.GetINISetting("settings","xmlSource","",sINI)
			' Start the import from the file
			xmlfile = CreateObject("Microsoft.XMLDOM")
				xmlfile.async=false
				xmlfile.load(strXMLFile)
				hs.SaveINISetting("Debug","ErrorCodeForecast",xmlfile.parseError.errorcode,sINI)
				if xmlfile.parseError.errorcode <> 0 Then
					fs.Add("There was an error with the XML file.  Error Reason: ")
					fs.Add(xmlfile.parseError.reason)
					hs.WriteLog(IName,fs.Value)
					fs.Reset
					dRun = dRun.addMinutes(-30)
					hs.SaveINISetting("Settings","lastranWUF",dRun,sINI)
					hs.SaveINISetting("Debug","ErrorReasonForecast",xmlfile.parseError.reason,sINI)
					hs.SaveINISetting("Debug","ErrorTimeForecast",trim(Now()),sINI)
				End if
				if xmlfile.parseError.errorcode = 0 Then
					clearINIData(10)
					clearOldINIData(20)
					setDeviceForecastClear()
					oNodeList = xmlfile.selectNodes("response/forecast/simpleforecast/forecastdays")
						oNode = oNodeList.nextNode
						xNode = oNode.selectNodes("forecastday")
						if debugMode = True Then
							hs.WriteLog(IName,"Set forecast information")
						End if
						if NOT xNode Is Nothing Then
							For x = 0 to oNode.selectNodes("forecastday").length-1
								sValue = oNode.selectNodes("forecastday").Item(x).selectSingleNode("date").selectSingleNode("monthname").text
								sValue2 = oNode.selectNodes("forecastday").Item(x).selectSingleNode("date").selectSingleNode("day").text
								sYear = oNode.selectNodes("forecastday").Item(x).selectSingleNode("date").selectSingleNode("year").text
								fs.Add("DayDate")
								fs.Add(x+1)
								sKey = fs.Value
								fs.Reset
								fs.Add(sValue)
								fs.Add("/")
								fs.Add(sValue2)
								fs.Add("/")
								fs.Add(sYear)
								hs.SaveINISetting("Forecast",sKey,fs.Value,sINI)
								sDate = fs.Value
								fs.Reset
								fs.Add("DayName")
								fs.Add(x+1)
								sKey = fs.Value
								sValue = oNode.selectNodes("forecastday").Item(x).selectSingleNode("date").selectSingleNode("weekday").text
								hs.SaveINISetting("Forecast",sKey,sValue,sINI)
								sDay = sValue
								fs.Reset
								if unitTemp = "F" Then
									sValue = oNode.selectNodes("forecastday").Item(x).selectSingleNode("high").selectSingleNode("fahrenheit").text									
								Else
									sValue = oNode.selectNodes("forecastday").Item(x).selectSingleNode("high").selectSingleNode("celsius").text
								End if
								fs.Add("DayHi")
								fs.Add(x+1)
								sKey = fs.Value
								hs.SaveINISetting("Forecast",sKey,sValue,sINI)
								sHi = sValue
								fs.Reset
								if unitTemp = "F" Then
									sValue = oNode.selectNodes("forecastday").Item(x).selectSingleNode("low").selectSingleNode("fahrenheit").text									
								Else
									sValue = oNode.selectNodes("forecastday").Item(x).selectSingleNode("low").selectSingleNode("celsius").text
								End if
								fs.Add("DayLow")
								fs.Add(x+1)
								sKey = fs.Value
								hs.SaveINISetting("Forecast",sKey,sValue,sINI)
								sLow = sValue
								fs.Reset
								sValue = oNode.selectNodes("forecastday").Item(x).selectSingleNode("conditions").text
								fs.Add("DayCondition")
								fs.Add(x+1)
								sKey = fs.Value
								hs.SaveINISetting("Forecast",sKey,sValue,sINI)
								sCond = sValue
								fs.Reset
								sValue = oNode.selectNodes("forecastday").Item(x).selectSingleNode("pop").text
								fs.Add("DayPrecipitation")
								fs.Add(x+1)
								sKey = fs.Value
								hs.SaveINISetting("Forecast",sKey,sValue,sINI)
								sPrecip = sValue
								fs.Reset
								sValue = oNode.selectNodes("forecastday").Item(x).selectSingleNode("icon_url").text
								fs.Add("DayIcon")
								fs.Add(x+1)
								sKey = fs.Value
								hs.SaveINISetting("Forecast",sKey,sValue,sINI)
								fs.Reset
								fs.Add("DayIconName")
								fs.Add(x+1)
								sKey = fs.Value
								sIconName = saveIcon(sValue)
								hs.SaveINISetting("Forecast",sKey,sIconName,sINI)
								fs.Reset
								fs.Add("DayForecast")
								fs.Add(x+1)
								sKey = fs.Value
								sValue = buildForecast(sDay, sDate, sCond, sHi, sLow, sPrecip)
								if debugMode = True Then
									hs.WriteLog(IName,"Forecast: " & sValue)
								End if
								hs.SaveINISetting("Forecast",sKey,sValue,sINI)
								fs.Reset
								' Set the rest to blank								
								fs.Add("NightCondition")
								fs.Add(x+1)
								sKey = fs.Value
								hs.SaveINISetting("Forecast",sKey,"",sINI)
								fs.Reset
								fs.Add("NightPrecipitation")
								fs.Add(x+1)
								sKey = fs.Value
								hs.SaveINISetting("Forecast",sKey,"",sINI)
								fs.Reset
								fs.Add("NightIcon")
								fs.Add(x+1)
								sKey = fs.Value
								hs.SaveINISetting("Forecast",sKey,"",sINI)
								fs.Reset
								fs.Add("NightIconName")
								fs.Add(x+1)
								sKey = fs.Value
								hs.SaveINISetting("Forecast",sKey,"",sINI)
								fs.Reset
								fs.Add("NightForecast")
								fs.Add(x+1)
								sKey = fs.Value
								hs.SaveINISetting("Forecast",sKey,"",sINI)
								fs.Reset
							Next
						End if
					oNodeList = Nothing
					if debugMode = True Then
						hs.WriteLog(IName,"Start forecast devices")
					End if
					oNodeList = xmlfile.selectNodes("response/forecast/txt_forecast/forecastdays")
						if oNodeList Is Nothing Then
							hs.WriteLog(Iname,"oNodeList = nothing")
						End if
						if UseMarquee = "True" Then
							sMarS = " * "
							sMarE = " "
						Else
							sMarS = "<li>"
							sMarE = "</li>"
						End if
						oNode = oNodeList.nextNode
						xNode = oNode.selectNodes("forecastday")
						sNext = "Today"
						if NOT xNode Is Nothing Then
							if UseMarquee = True Then
								ss.Add("<marquee behavior=""scroll"" align=""left"" direction=""left"">")
							Else
								ss.Add("<ul>")
							End if
							For x = 0 to oNode.selectNodes("forecastday").length-1
								sValue = oNode.selectNodes("forecastday").Item(x).selectSingleNode("title").text
								if inStr(sValue,"Tonight") > 1 Then
									sNext = "Tonight"
								End if
								sValue2 = ""
								if lCase(hs.GetINISetting("InfoUnit","Temperature","F",sINI)) = "F" Then
									xNode = oNode.selectNodes("forecastday").Item(x).selectSingleNode("fcttext")
									if NOT xNode Is Nothing Then
										sValue2 = oNode.selectNodes("forecastday").Item(x).selectSingleNode("fcttext").text
									Else
										xNode = oNode.selectNodes("forecastday").Item(x).selectSingleNode("fcttext_metric")
										if NOT xNode Is Nothing Then
											sValue2 = oNode.selectNodes("forecastday").Item(x).selectSingleNode("fcttext_metric").text
										End if
									End if
								Else
									xNode = oNode.selectNodes("forecastday").Item(x).selectSingleNode("fcttext_metric")
									if NOT xNode Is Nothing Then
										sValue2 = oNode.selectNodes("forecastday").Item(x).selectSingleNode("fcttext_metric").text
									Else
										xNode = oNode.selectNodes("forecastday").Item(x).selectSingleNode("fcttext")
										if NOT xNode Is Nothing Then
											sValue2 = oNode.selectNodes("forecastday").Item(x).selectSingleNode("fcttext").text
										End if
									End if								
								End if
								if sNext = "Today" Then
									sPeriod = "Today"
									sNext = "Tonight"
									fDev=hs.GetINISetting("Settings","forecastToday","",sINI)
								Elseif sNext = "Tonight" Then
									sPeriod = "Tonight"
									sNext = "Tomorrow"
									fDev = hs.GetINISetting ("Settings","forecastTonight","",sINI)
								Elseif sNext = "Tomorrow" Then
									sPeriod = "Tomorrow"
									sNext = "Tomorrow Night"
									fDev=hs.GetINISetting("Settings","forecastTomorrow","",sINI)
								Elseif sNext = "Tomorrow Night" Then
									sPeriod = "Tomorrow Night"
									sNext = "Other"
									fDev = hs.GetINISetting ("Settings","forecastTomorrowNight","",sINI)
									fNext = "forecast2Day"
								Elseif sNext = "Other" Then
									sPeriod = sValue
									Select case fNext
										Case "forecast2Day"
											fDev = hs.GetINISetting ("Settings","forecast2Day","",sINI)
											fNext = "forecast3Day"
										Case "forecast3Day"
											fDev = hs.GetINISetting ("Settings","forecast3Day","",sINI)
											fNext = "forecast4Day"
										Case "forecast4Day"
											fDev = hs.GetINISetting ("Settings","forecast4Day","",sINI)
											fNext = "forecast5Day"
										Case "forecast5Day"
											fDev = hs.GetINISetting ("Settings","forecast5Day","",sINI)
											fNext = "forecast6Day"
										Case "forecast6Day"
											fDev = hs.GetINISetting ("Settings","forecast6Day","",sINI)
											fNext = "forecast7Day"
										Case "forecast7Day"
											fDev = hs.GetINISetting ("Settings","forecast7Day","",sINI)
											fNext = "forecast8Day"
										Case "forecast8Day"
											fDev = ""
									End Select
								End if
								fs.Add("ExtForecast")
								fs.Add(x+1)
								sKey = fs.Value
								fs.Reset
								fs.Add(sPeriod)
								fs.Add(": ")
								fs.Add(sValue2)
								hs.SaveINISetting("WeatherCom_ExtForecast",sKey,fs.Value,sINI)
								' Carry the string for the forecast device
								ss.Add(sMarS)
								ss.Add(trim(fs.Value))
								ss.Add(sMarE)
								if len(trim(fDev)) > 0 Then
									hs.SetDeviceString(fDev,trim(fs.Value),True)
								End if
								fs.Reset
							Next
							if UseMarquee = True Then
								ss.Add("</marquee>")
							Else
								ss.Add("</ul>")
							End if
							fDev = hs.GetINISetting ("Settings","devForecast","",sINI)
							if len(trim(fDev)) > 0 Then
								hs.SetDeviceString(fDev,trim(ss.Value),True)
							End if
						End if
					oNodeList = Nothing
				End if
			xmlfile = Nothing
		ss = Nothing
		fs = Nothing
	Catch e as Exception
		hs.WriteLog(IName,"importForecast: " & e.message)
	End Try	
End Sub

Sub importHourly(Optional ByVal sParam as String = "")
	importForecastHourly(hs.GetAppPath & "\data\weathercom_xml\WUhourly7day.xml")
End Sub

Sub importForecastHourly(ByVal strXMLFile as String)
	Dim dRun as Date
	Dim x as Integer
	Dim fs, ss, xmlfile, oNodeList, oNode, xNode as Object
	Dim unitTemp, unitSpeed, sValue as String
	Try
		getINIValues()
		fs = hs.CreateStringClass
		ss = hs.CreateStringClass
			unitTemp = hs.GetINISetting("InfoUnit","Temperature","F",sINI)
			unitSpeed = hs.GetINISetting("InfoUnit","SpeedUnit","mph",sINI)
			' Start the import from the file
			xmlfile = CreateObject("Microsoft.XMLDOM")
				xmlfile.async=false
				xmlfile.load(strXMLFile)
				hs.SaveINISetting("Debug","ErrorCodeHourly7Day",xmlfile.parseError.errorcode,sINI)
				if xmlfile.parseError.errorcode <> 0 Then
					fs.Add("There was an error with the XML file.  Error Reason: ")
					fs.Add(xmlfile.parseError.reason)
					hs.WriteLog(IName,fs.Value)
					fs.Reset
					dRun = dRun.addMinutes(-30)
					hs.SaveINISetting("Settings","lastranWUH",dRun,sINI)
					hs.SaveINISetting("Debug","ErrorReasonHourly7Day",xmlfile.parseError.reason,sINI)
					hs.SaveINISetting("Debug","ErrorTimeHourly7Day",trim(Now()),sINI)
				End if
				if xmlfile.parseError.errorcode = 0 Then
					oNodeList = xmlfile.selectNodes("response/hourly_forecast")
						oNode = oNodeList.nextNode
						xNode = oNode.selectNodes("forecast")
						if debugMode = True Then
							hs.WriteLog(IName,"Getting hourly forecast information")
						End if
						if NOT xNode Is Nothing Then
							for x = 170 to 120 Step -1
								fs.Add("hourTime")
								fs.Add(x)
								if len(trim(hs.GetINISetting("HourlyForecast",fs.Value,"",sINI2))) > 0 Then
									hs.SaveINISetting("HourlyForecast",fs.Value,"",sINI2)
								End if
								fs.Reset
								fs.Add("hourTemp")
								fs.Add(x)
								if len(trim(hs.GetINISetting("HourlyForecast",fs.Value,"",sINI2))) > 0 Then
									hs.SaveINISetting("HourlyForecast",fs.Value,"",sINI2)
								End if
								fs.Reset
								fs.Add("hourDewp")
								fs.Add(x)
								if len(trim(hs.GetINISetting("HourlyForecast",fs.Value,"",sINI2))) > 0 Then
									hs.SaveINISetting("HourlyForecast",fs.Value,"",sINI2)
								End if
								fs.Reset
								fs.Add("hourCond")
								fs.Add(x)
								if len(trim(hs.GetINISetting("HourlyForecast",fs.Value,"",sINI2))) > 0 Then
									hs.SaveINISetting("HourlyForecast",fs.Value,"",sINI2)
								End if
								fs.Reset
								fs.Add("hourIcon")
								fs.Add(x)
								if len(trim(hs.GetINISetting("HourlyForecast",fs.Value,"",sINI2))) > 0 Then
									hs.SaveINISetting("HourlyForecast",fs.Value,"",sINI2)
								End if
								fs.Reset
								fs.Add("hourIconName")
								fs.Add(x)
								if len(trim(hs.GetINISetting("HourlyForecast",fs.Value,"",sINI2))) > 0 Then
									hs.SaveINISetting("HourlyForecast",fs.Value,"",sINI2)
								End if
								fs.Reset
							Next
							for x = 0 to oNode.selectNodes("forecast").length-1
								xNode = oNode.selectNodes("forecast").Item(x).selectSingleNode("FCTTIME").selectSingleNode("pretty")
								if NOT xNode Is Nothing Then
									sValue = oNode.selectNodes("forecast").Item(x).selectSingleNode("FCTTIME").selectSingleNode("pretty").text 
								Else
									sValue = ""
								End if
								fs.Add("hourTime")
								fs.Add(x+1)
								hs.SaveINISetting("HourlyForecast",fs.Value,sValue,sINI2)
								fs.Reset
								if lCase(unitTemp) = "f" Then
									xNode = oNode.selectNodes("forecast").Item(x).selectSingleNode("temp").selectSingleNode("english")
								Else
									xNode = oNode.selectNodes("forecast").Item(x).selectSingleNode("temp").selectSingleNode("metric")
								End if
								if NOT xNode Is Nothing Then
									if lCase(unitTemp) = "f" Then
										sValue = oNode.selectNodes("forecast").Item(x).selectSingleNode("temp").selectSingleNode("english").text
									Else
										sValue = oNode.selectNodes("forecast").Item(x).selectSingleNode("temp").selectSingleNode("metric").text
									End if
								Else
									sValue = ""
								End if
								fs.Add("hourTemp")
								fs.Add(x+1)
								hs.SaveINISetting("HourlyForecast",fs.Value,sValue,sINI2)
								fs.Reset
								if lCase(unitTemp) = "f" Then
									xNode = oNode.selectNodes("forecast").Item(x).selectSingleNode("dewpoint").selectSingleNode("english")
								Else
									xNode = oNode.selectNodes("forecast").Item(x).selectSingleNode("dewpoint").selectSingleNode("metric")
								End if
								if NOT xNode Is Nothing Then
									if lCase(unitTemp) = "f" Then
										sValue = oNode.selectNodes("forecast").Item(x).selectSingleNode("dewpoint").selectSingleNode("english").text
									Else
										sValue = oNode.selectNodes("forecast").Item(x).selectSingleNode("dewpoint").selectSingleNode("metric").text
									End if
								Else
									sValue = ""
								End if								
								fs.Add("hourDewp")
								fs.Add(x+1)
								hs.SaveINISetting("HourlyForecast",fs.Value,sValue,sINI2)
								fs.Reset
								xNode = oNode.selectNodes("forecast").Item(x).selectSingleNode("condition")
								if NOT xNode Is Nothing Then
									sValue = oNode.selectNodes("forecast").Item(x).selectSingleNode("condition").text
								Else
									sValue = ""
								End if
								fs.Add("hourCond")
								fs.Add(x+1)
								hs.SaveINISetting("HourlyForecast",fs.Value,sValue,sINI2)
								fs.Reset
								xNode = oNode.selectNodes("forecast").Item(x).selectSingleNode("icon_url")
								if NOT xNode Is Nothing Then
									sValue = oNode.selectNodes("forecast").Item(x).selectSingleNode("icon_url").text
								Else
									sValue = ""
								End if
								fs.Add("hourIcon")
								fs.Add(x+1)
								hs.SaveINISetting("HourlyForecast",fs.Value,sValue,sINI2)
								fs.Reset
								fs.Add("hourIconName")
								fs.Add(x+1)
								hs.SaveINISetting("HourlyForecast",fs.Value,saveIcon(sValue),sINI2)
								fs.Reset
								if lCase(unitSpeed) = "mph" Then
									xNode = oNode.selectNodes("forecast").Item(x).selectSingleNode("wspd").selectSingleNode("english")
								Else
									xNode = oNode.selectNodes("forecast").Item(x).selectSingleNode("wspd").selectSingleNode("metric")
								End if
								if NOT xNode Is Nothing Then
									if lCase(unitSpeed) = "mph" Then
										sValue = oNode.selectNodes("forecast").Item(x).selectSingleNode("wspd").selectSingleNode("english").text
									Else
										sValue = oNode.selectNodes("forecast").Item(x).selectSingleNode("wspd").selectSingleNode("metric").text
									End if
								Else
									sValue = ""
								End if	
								fs.Add("hourWSpd")
								fs.Add(x+1)
								hs.SaveINISetting("HourlyForecast",fs.Value,sValue,sINI2)
								fs.Reset
								xNode = oNode.selectNodes("forecast").Item(x).selectSingleNode("wdir").selectSingleNode("dir")
								if NOT xNode Is Nothing Then
									sValue = oNode.selectNodes("forecast").Item(x).selectSingleNode("wdir").selectSingleNode("dir").text
								Else
									sValue = ""
								End if
								fs.Add("hourWDir")
								fs.Add(x+1)
								hs.SaveINISetting("HourlyForecast",fs.Value,sValue,sINI2)
								fs.Reset
								xNode = oNode.selectNodes("forecast").Item(x).selectSingleNode("uvi")
								if NOT xNode Is Nothing Then
									sValue = oNode.selectNodes("forecast").Item(x).selectSingleNode("uvi").text
								Else
									sValue = ""
								End if
								fs.Add("hourUVIn")
								fs.Add(x+1)
								hs.SaveINISetting("HourlyForecast",fs.Value,sValue,sINI2)
								fs.Reset
								xNode = oNode.selectNodes("forecast").Item(x).selectSingleNode("humidity")
								if NOT xNode Is Nothing Then
									sValue = oNode.selectNodes("forecast").Item(x).selectSingleNode("humidity").text
								Else
									sValue = ""
								End if
								fs.Add("hourHumi")
								fs.Add(x+1)
								hs.SaveINISetting("HourlyForecast",fs.Value,sValue,sINI2)
								fs.Reset
								if lCase(unitTemp) = "f" Then
									xNode = oNode.selectNodes("forecast").Item(x).selectSingleNode("windchill").selectSingleNode("english")
								Else
									xNode = oNode.selectNodes("forecast").Item(x).selectSingleNode("windchill").selectSingleNode("metric")
								End if
								if NOT xNode Is Nothing Then
									if lCase(unitTemp) = "f" Then
										sValue = oNode.selectNodes("forecast").Item(x).selectSingleNode("windchill").selectSingleNode("english").text
									Else
										sValue = oNode.selectNodes("forecast").Item(x).selectSingleNode("windchill").selectSingleNode("metric").text
									End if
								Else
									sValue = ""
								End if								
								fs.Add("hourWchl")
								fs.Add(x+1)
								hs.SaveINISetting("HourlyForecast",fs.Value,sValue,sINI2)
								fs.Reset
								if lCase(unitTemp) = "f" Then
									xNode = oNode.selectNodes("forecast").Item(x).selectSingleNode("heatindex").selectSingleNode("english")
								Else
									xNode = oNode.selectNodes("forecast").Item(x).selectSingleNode("heatindex").selectSingleNode("metric")
								End if
								if NOT xNode Is Nothing Then
									if lCase(unitTemp) = "f" Then
										sValue = oNode.selectNodes("forecast").Item(x).selectSingleNode("heatindex").selectSingleNode("english").text
									Else
										sValue = oNode.selectNodes("forecast").Item(x).selectSingleNode("heatindex").selectSingleNode("metric").text
									End if
								Else
									sValue = ""
								End if								
								fs.Add("hourHInd")
								fs.Add(x+1)
								hs.SaveINISetting("HourlyForecast",fs.Value,sValue,sINI2)
								fs.Reset
								if lCase(unitTemp) = "f" Then
									xNode = oNode.selectNodes("forecast").Item(x).selectSingleNode("feelslike").selectSingleNode("english")
								Else
									xNode = oNode.selectNodes("forecast").Item(x).selectSingleNode("feelslike").selectSingleNode("metric")
								End if
								if NOT xNode Is Nothing Then
									if lCase(unitTemp) = "f" Then
										sValue = oNode.selectNodes("forecast").Item(x).selectSingleNode("feelslike").selectSingleNode("english").text
									Else
										sValue = oNode.selectNodes("forecast").Item(x).selectSingleNode("feelslike").selectSingleNode("metric").text
									End if
								Else
									sValue = ""
								End if								
								fs.Add("hourFeels")
								fs.Add(x+1)
								hs.SaveINISetting("HourlyForecast",fs.Value,sValue,sINI2)
								fs.Reset
								if lCase(unitTemp) = "f" Then
									xNode = oNode.selectNodes("forecast").Item(x).selectSingleNode("snow").selectSingleNode("english")
								Else
									xNode = oNode.selectNodes("forecast").Item(x).selectSingleNode("snow").selectSingleNode("metric")
								End if
								if NOT xNode Is Nothing Then
									if lCase(unitTemp) = "f" Then
										sValue = oNode.selectNodes("forecast").Item(x).selectSingleNode("snow").selectSingleNode("english").text
									Else
										sValue = oNode.selectNodes("forecast").Item(x).selectSingleNode("snow").selectSingleNode("metric").text
									End if
								Else
									sValue = ""
								End if								
								fs.Add("hourSnow")
								fs.Add(x+1)
								hs.SaveINISetting("HourlyForecast",fs.Value,sValue,sINI2)
								fs.Reset
								xNode = oNode.selectNodes("forecast").Item(x).selectSingleNode("pop")
								if NOT xNode Is Nothing Then
									sValue = oNode.selectNodes("forecast").Item(x).selectSingleNode("pop").text
								Else
									sValue = ""
								End if
								fs.Add("hourPop%")
								fs.Add(x+1)
								hs.SaveINISetting("HourlyForecast",fs.Value,sValue,sINI2)
								fs.Reset
								if lCase(unitTemp) = "f" Then
									xNode = oNode.selectNodes("forecast").Item(x).selectSingleNode("qpf").selectSingleNode("english")
								Else
									xNode = oNode.selectNodes("forecast").Item(x).selectSingleNode("qpf").selectSingleNode("metric")
								End if
								if NOT xNode Is Nothing Then
									if lCase(unitTemp) = "f" Then
										sValue = oNode.selectNodes("forecast").Item(x).selectSingleNode("qpf").selectSingleNode("english").text
									Else
										sValue = oNode.selectNodes("forecast").Item(x).selectSingleNode("qpf").selectSingleNode("metric").text
									End if
								Else
									sValue = ""
								End if								
								fs.Add("hourTqpf")
								fs.Add(x+1)
								hs.SaveINISetting("HourlyForecast",fs.Value,sValue,sINI2)
								fs.Reset
							Next
						End if
					oNodeList = Nothing
				End if
			xmlfile = Nothing
		ss = Nothing
		fs = Nothing
	Catch e as Exception
		hs.WriteLog(IName,"importForecastHourly: " & e.message)
	End Try	
End Sub

Sub importHistory(ByVal strXMLFile as String)
	Dim dRun as Date
	Dim fs, FSO, xmlfile, oNodeList, oNode as Object
	Dim sValue, sTemp, unitTemp as String
	Try
		getINIValues()
		fs = hs.CreateStringClass
			' Start the import from the file
			xmlfile = CreateObject("Microsoft.XMLDOM")
				xmlfile.async=false
				xmlfile.load(strXMLFile)
				hs.SaveINISetting("Debug","ErrorCodeHistory",xmlfile.parseError.errorcode,sINI)
				if xmlfile.parseError.errorcode <> 0 Then
					fs.Add("There was an error with the XML file.  Error Reason: ")
					fs.Add(xmlfile.parseError.reason)
					hs.WriteLog(IName,fs.Value)
					fs.Reset
					dRun = dRun.addMinutes(-30)
					hs.SaveINISetting("Settings","lastranHistory",dRun,sINI)
					hs.SaveINISetting("Debug","ErrorReasonHistory",xmlfile.parseError.reason,sINI)
					hs.SaveINISetting("Debug","ErrorTimeHistory",trim(Now()),sINI)
				End if
				if xmlfile.parseError.errorcode = 0 Then
					unitTemp = hs.GetINISetting("InfoUnit","Temperature","F",sINI)
					oNodeList = xmlfile.selectNodes("response/history/dailysummary/summary")
					if Not oNodeList Is Nothing THen
						oNode = oNodeList.nextNode
						if Not oNode Is Nothing Then
							if unitTemp = "F" Then
								sTemp = oNode.selectSingleNode("maxtempi").text
								sValue= oNode.selectSingleNode("mintempi").text								
							Else
								sTemp = oNode.selectSingleNode("maxtempm").text
								sValue= oNode.selectSingleNode("mintempm").text								
							End if
							hs.SaveINISetting("WeatherInfo","TempYearAgoHigh",sTemp,sINI)
							setDeviceLastYearHigh(sTemp)
							hs.SaveINISetting("WeatherInfo","TempYearAgoLow",sValue,sINI)
							setDeviceLastYearLow(sValue)
							fs.Reset
						End if
					End if
					oNodeList = Nothing
					if debugMode = true Then
						hs.WriteLog(IName,"Finished importing weather underground history.")
					End if
				End if
			xmlfile = Nothing
		fs = Nothing
	Catch e as Exception
		hs.WriteLog(IName,"importHistory: " & e.message)
	End Try
End Sub

Function ReverseString(ByVal InputString As String) As String
	Dim lLen, lCtr as Long
	Dim rs as Object
	Dim sChar as String
	Dim sAns as String
	rs = hs.CreateStringClass
		lLen = Len(InputString)
		For lCtr = lLen To 1 Step -1
			sChar = Mid(InputString, lCtr, 1)
			rs.Add(sChar)
		Next
		Return rs.Value
	rs = Nothing
End Function

Function saveIcon(ByVal sURL as String)
	Dim pos1 as Integer
	Dim ci as Object
	Dim sDomain, sFile, sImage, sFileName, sSaveTo, sReverse as string
	Try
		ci = hs.CreateStringClass
			sImage = replace(sURL,"http://","")
			pos1 = inStr(sImage,"/")-1
			sDomain = left(sImage,pos1)
			sFile = replace(sImage,sDomain,"")
			sReverse = ReverseString(sFile)
			pos1 = inStr(sReverse,"/")-1
			sFileName = left(sReverse,pos1)
			sFileName = ReverseString(sFileName)
			ci.Add(hs.GetAppPath)
			ci.Add("\html\Images\weathericons\condition\")
			ci.Add(sFileName)
			sSaveTo = ci.Value
			ci.Reset
			if File.Exists(sSaveTo) Then
				if debugMode = True Then 
					ci.Add("File: ")
					ci.Add(sSaveTo)
					ci.Add(" already exists.  Do not download. ")
					hs.WriteLog(IName,ci.Value)
					ci.Reset
				End if
			Else
				if debugMode = True Then
					ci.Add("Save forecast image to: ")
					ci.Add(sSaveTo)
					hs.WriteLog(IName,ci.Value)
					ci.Reset
				End if
				hs.GetURLImage(sDomain,sFile,True,80,sSaveTo)
			End if
		ci = Nothing
	Catch e as Exception
		hs.WriteLog(IName,"saveIcon: " & e.Message)
	End Try
	Return sFileName
End Function

Sub setDeviceForecastClear(Optional ByVal sParam as String = "")
	Dim fDev as String
	fDev = hs.GetINISetting ("Settings","devForecast","",sINI)
	if len(trim(fDev)) > 0 Then
		hs.SetDeviceString(fDev,"",true)
		hs.SetDeviceStatus(fDev,3)
	End if	
	fDev=hs.GetINISetting("Settings","forecastToday","",sINI)
	if len(trim(fDev)) > 0 Then
		hs.SetDeviceString(fDev,"",true)
		hs.SetDeviceStatus(fDev,3)
	End if	
	fDev = hs.GetINISetting ("Settings","forecastTonight","",sINI)
	if len(trim(fDev)) > 0 Then
		hs.SetDeviceString(fDev,"",True)
		hs.SetDeviceStatus(fDev,3)
	End if
	fDev = hs.GetINISetting ("Settings","forecastTomorrow","",sINI)
	if len(trim(fDev)) > 0 Then
		hs.SetDeviceString(fDev,"",True)
		hs.SetDeviceStatus(fDev,3)
	End if
	fDev = hs.GetINISetting ("Settings","forecastTomorrowNight","",sINI)
	if len(trim(fDev)) > 0 Then
		hs.SetDeviceString(fDev,"",True)
		hs.SetDeviceStatus(fDev,3)
	End if
	fDev = hs.GetINISetting ("Settings","forecast2Day","",sINI)
	if len(trim(fDev)) > 0 Then
		hs.SetDeviceString(fDev,"",True)
		hs.SetDeviceStatus(fDev,3)
	End if
	fDev = hs.GetINISetting ("Settings","forecast3Day","",sINI)
	if len(trim(fDev)) > 0 Then
		hs.SetDeviceString(fDev,"",True)
		hs.SetDeviceStatus(fDev,3)
	End if
	fDev = hs.GetINISetting ("Settings","forecast4Day","",sINI)
	if len(trim(fDev)) > 0 Then
		hs.SetDeviceString(fDev,"",True)
		hs.SetDeviceStatus(fDev,3)
	End if
	fDev = hs.GetINISetting ("Settings","forecast5Day","",sINI)
	if len(trim(fDev)) > 0 Then
		hs.SetDeviceString(fDev,"",True)
		hs.SetDeviceStatus(fDev,3)
	End if
	fDev = hs.GetINISetting ("Settings","forecast6Day","",sINI)
	if len(trim(fDev)) > 0 Then
		hs.SetDeviceString(fDev,"",True)
		hs.SetDeviceStatus(fDev,3)
	End if
	fDev = hs.GetINISetting ("Settings","forecast7Day","",sINI)
	if len(trim(fDev)) > 0 Then
		hs.SetDeviceString(fDev,"",True)
		hs.SetDeviceStatus(fDev,3)
	End if
End Sub

Sub setDeviceLastYearHigh(ByVal sTempHigh as String)
	Dim fs as Object
	Dim devTempHistory as String
	Try
		hs.SaveINISetting("WeatherInfo","TempYearAgoHigh",sTempHigh,sINI)
		devTempHistory = hs.GetINISetting ("Settings","devTempLastYearHigh","",sINI)
		if len(trim(devTempHistory)) > 0 Then
			if len(trim(sTempHigh)) = 0 Then
				hs.SetDeviceString(devTempHistory,"N/A",True)
			Else
				fs = hs.CreateStringClass
					fs.Add(sTableStartCode)
					if UseIcons = True AND sTempHigh <> "N/A" Then
						fs.Add("<img src='\images\weathericons\thermos\")
						fs.Add(sTempHigh)
						fs.Add(".gif' width='36' height='77' align='middle'>")
					End if
					fs.Add(sTableMidCode)
					if useHeadings = True Then
						fs.Add(useHeadingStyle)
						fs.Add(hs.GetINISetting("Language","devTempLastYearHighLbl","De hoogste temperatuur vandaag vorig jaar",sINI))
						fs.Add(":</span><br/>")
					End if
					fs.Add(sTempHigh)
					fs.Add("&deg; ")
					fs.Add(hs.GetINISetting("InfoUnit","Temperature","",sINI))
					fs.Add(". ")
					fs.Add(sTableEndCode)
					hs.SetDeviceString(devTempHistory,fs.Value,True)
					hs.SetDeviceValue(devTempHistory,sTempHigh)
					fs.Reset
				fs = Nothing
			End if
		End if
	Catch e as Exception
		hs.WriteLog(Iname,"setDeviceLastYearHigh=" & e.Message)
	End Try
End Sub

Sub setDeviceLastYearLow(ByVal sTempLow as String)
	Dim fs as Object
	Dim devTempHistory as String
	Try
		hs.SaveINISetting("WeatherInfo","TempYearAgoLow",sTempLow,sINI)
		devTempHistory = hs.GetINISetting ("Settings","devTempLastYearLow","",sINI)
		if len(trim(devTempHistory)) > 0 Then
			if len(trim(sTempLow)) = 0 Then
				hs.SetDeviceString(devTempHistory,"N/A",True)
			Else
				fs = hs.CreateStringClass
					fs.Add(sTableStartCode)
					if UseIcons = True AND sTempLow <> "N/A" Then
						fs.Add("<img src='\images\weathericons\thermos\")
						fs.Add(sTempLow)
						fs.Add(".gif' width='36' height='77' align='middle'>")
					End if
					fs.Add(sTableMidCode)
					if useHeadings = True Then
						fs.Add(useHeadingStyle)
						fs.Add(hs.GetINISetting("Language","devTempLastYearLowLbl","De laagste temperatuur vandaag vorig jaar",sINI))
						fs.Add(":</span><br/>")
					End if
					fs.Add(sTempLow)
					fs.Add("&deg; ")
					fs.Add(hs.GetINISetting("InfoUnit","Temperature","",sINI))
					fs.Add(". ")
					fs.Add(sTableEndCode)
					hs.SetDeviceString(devTempHistory,fs.Value,True)
					hs.SetDeviceValue(devTempHistory,sTempLow)
					fs.Reset
				fs = Nothing
			End if
		End if
	Catch e as Exception
		hs.WriteLog(Iname,"setDeviceLastYearLow=" & e.Message)
	End Try
End Sub

Sub setDeviceMoonPhase(ByVal sDay as String,ByVal sBright as String)
	Dim fs as Object
	Dim fDev, sLabel as String
	Dim dtStart as Date = Now
   	Dim NMoon, FMoon as Date
   	Dim CurCycle as Integer
   	Dim sDesc as String = ""
	Try
		hs.SaveINISetting("WeatherInfo","moonPhase",sDay,sINI)
		hs.SaveINISetting("WeatherInfo","moonIllum",sBright,sINI)
		fDev = hs.GetINISetting("Settings","devMoonPhase","",sINI)
		if len(trim(fDev)) > 0 Then
			hs.Moon(dtStart, NMoon, FMoon, CurCycle, sDesc)
			sLabel = hs.GetINISetting("Language","devMoonPhaseLbl","Maanfase",sINI)
			fs = hs.CreateStringClass
				fs.Add(sTableStartCode)
				if UseIcons = True AND sDay <> "N/A" Then
					fs.Add("<img src='\images\weathericons\moon\moon")
					fs.Add(sDay)
					fs.Add(".gif' width='36' ='77' align='middle'>")
				End if
				fs.Add(sTableMidCode)
				if useHeadings = True Then
					fs.Add(useHeadingStyle)
					fs.Add(hs.GetINISetting("Language","devMoonPhaseLbl","Maanfase",sINI))
					fs.Add(":</span><br/>")
				End if
				fs.Add("Maanfase: ")
				fs.Add(sDay)
				fs.Add("<br/>fase: ")
				'fs.Add(trim(sDesc))
				fs.Add(lcase(hs.GetINISetting("Language Moon phases",sDesc,sDesc,sINI)))
				fs.Add("<br/>Schijngestalte: ")
				fs.Add(sBright)
				fs.Add("%. ")
				fs.Add("<br/>Nieuwe maan op: ")
				fs.Add(NMoon.ToShortDateString)
				fs.Add("<br/>Volle maan op: ")
				fs.Add(FMoon.ToShortDateString)
				fs.Add(sTableEndCode)
				hs.SetDeviceString(fDev,fs.Value,True)
				hs.SetDeviceValue(fDev,sBright)
				fs.Reset
			fs = Nothing
		End if
	Catch e as Exception
		hs.WriteLog(IName,"setDeviceMoonPhase: " & e.Message)
	End Try
End Sub

Sub setDeviceTempHistHigh(ByVal node1 as String)
	Dim fs as Object
	Dim devTempHistory as String
	Try
		hs.SaveINISetting("WeatherInfo","TempLastYearHigh",node1,sINI)
		devTempHistory = hs.GetINISetting ("Settings","devTempHistory","",sINI)
		if len(trim(devTempHistory)) > 0 Then
			if len(trim(node1)) = 0 Then
				hs.SetDeviceString(devTempHistory,"N/A",True)
			Else
				fs = hs.CreateStringClass
					fs.Add(sTableStartCode)
					if UseIcons = True AND node1 <> "N/A" Then
						fs.Add("<img src='\images\weathericons\thermos\")
						fs.Add(node1)
						fs.Add(".gif' width='36' height='77' align='middle'>")
					End if
					fs.Add(sTableMidCode)
					if useHeadings = True Then
						fs.Add(useHeadingStyle)
						fs.Add(hs.GetINISetting("Language","devTempHistoryLbl","Hoogste temperatuur vandaag",sINI))
						fs.Add(":</span><br/>")
					End if
					fs.Add(node1)
					fs.Add("° ")
					fs.Add(hs.GetINISetting("InfoUnit","Temperature","",sINI))
					fs.Add(". ")
					fs.Add(sTableEndCode)
					hs.SetDeviceString(devTempHistory,fs.Value,True)
					hs.SetDeviceValue(devTempHistory,node1)
					fs.Reset
				fs = Nothing
			End if
		End if
	Catch e as Exception
		hs.WriteLog(Iname,"setDeviceTempHistHigh=" & e.Message)
	End Try
End Sub

Sub setDeviceTempHistLow(ByVal node1 as String)
	Dim fs as Object
	Dim devTempHistory as String
	Try
		hs.SaveINISetting("WeatherInfo","TempLastYearLow",node1,sINI)
		devTempHistory = hs.GetINISetting ("Settings","devTempHistoryLow","",sINI)
		if len(trim(devTempHistory)) > 0 Then
			if len(trim(node1)) = 0 Then
				hs.SetDeviceString(devTempHistory,"N/A",True)
			Else
				fs = hs.CreateStringClass
					fs.Add(sTableStartCode)
					if UseIcons = True AND node1 <> "N/A" Then
						fs.Add("<img src='\images\weathericons\thermos\")
						fs.Add(node1)
						fs.Add(".gif' width='36' height='77' align='middle'>")
					End if
					fs.Add(sTableMidCode)
					if useHeadings = True Then
						fs.Add(useHeadingStyle)
						fs.Add(hs.GetINISetting("Language","devTempHistoryLowLbl","Laagste temperatuur vandaag",sINI))
						fs.Add(":</span><br/>")
					End if
					fs.Add(node1)
					fs.Add("° ")
					fs.Add(hs.GetINISetting("InfoUnit","Temperature","",sINI))
					fs.Add(". ")
					fs.Add(sTableEndCode)
					hs.SetDeviceString(devTempHistory,fs.Value,True)
					hs.SetDeviceValue(devTempHistory,node1)
					fs.Reset
				fs = Nothing
			End if
		End if
	Catch e as Exception
		hs.WriteLog(Iname,"setDeviceTempHistLow=" & e.Message)
	End Try
End Sub

Sub setDeviceTempRecordHigh(ByVal node1 as String, ByVal node2 as String)
	Dim fs as Object
	Dim devTempHistory as String
	Try
		hs.SaveINISetting("WeatherInfo","TempRecordHigh",node1,sINI)
		hs.SaveINISetting("WeatherInfo","TempRecordHighYear",node2,sINI)
		devTempHistory = hs.GetINISetting ("Settings","devTempRecordHigh","",sINI)
		if len(trim(devTempHistory)) > 0 Then
			if len(trim(node1)) = 0 Then
				hs.SetDeviceString(devTempHistory,"N/A",True)
			Else
				fs = hs.CreateStringClass
					fs.Add(sTableStartCode)
					if UseIcons = True AND node1 <> "N/A" Then
						fs.Add("<img src='\images\weathericons\thermos\")
						fs.Add(node1)
						fs.Add(".gif' width='36' height='77' align='middle'>")
					End if
					fs.Add(sTableMidCode)
					if useHeadings = True Then
						fs.Add(useHeadingStyle)
						fs.Add(hs.GetINISetting("Language","devTempRecordHighLbl","Hoogste temperatuur ooit voor vandaag",sINI))
						fs.Add(":</span><br/>")
					End if
					fs.Add(node1)
					fs.Add("° ")
					fs.Add(hs.GetINISetting("InfoUnit","Temperature","",sINI))
					fs.Add(".  Set in ")
					fs.Add(node2)
					fs.Add(". ")
					fs.Add(sTableEndCode)
					hs.SetDeviceString(devTempHistory,fs.Value,True)
					hs.SetDeviceValue(devTempHistory,node1)
					fs.Reset
				fs = Nothing
			End if
		End if
	Catch e as Exception
		hs.WriteLog(Iname,"setDeviceTempRecordHigh=" & e.Message)
	End Try
End Sub

Sub setDeviceTempRecordLow(ByVal node1 as String, ByVal node2 as String)
	Dim fs as Object
	Dim devTempHistory as String
	Try
		hs.SaveINISetting("WeatherInfo","TempRecordLow",node1,sINI)
		hs.SaveINISetting("WeatherInfo","TempRecordLowYear",node2,sINI)
		devTempHistory = hs.GetINISetting ("Settings","devTempRecordLow","",sINI)
		if len(trim(devTempHistory)) > 0 Then
			if len(trim(node1)) = 0 Then
				hs.SetDeviceString(devTempHistory,"N/A",True)
			Else
				fs = hs.CreateStringClass
					fs.Add(sTableStartCode)
					if UseIcons = True AND node1 <> "N/A" Then
						fs.Add("<img src='\images\weathericons\thermos\")
						fs.Add(node1)
						fs.Add(".gif' width='36' height='77' align='middle'>")
					End if
					fs.Add(sTableMidCode)
					if useHeadings = True Then
						fs.Add(useHeadingStyle)
						fs.Add(hs.GetINISetting("Language","devTempRecordLowLbl","Laagste temperatuur ooit voor vandaag",sINI))
						fs.Add(":</span><br/>")
					End if
					fs.Add(node1)
					fs.Add("° ")
					fs.Add(hs.GetINISetting("InfoUnit","Temperature","",sINI))
					fs.Add(".  Set in ")
					fs.Add(node2)
					fs.Add(". ")
					fs.Add(sTableEndCode)
					hs.SetDeviceString(devTempHistory,fs.Value,True)
					hs.SetDeviceValue(devTempHistory,node1)
					fs.Reset
				fs = Nothing
			End if
		End if
	Catch e as Exception
		hs.WriteLog(Iname,"setDeviceTempRecordLow=" & e.Message)
	End Try
End Sub
