﻿'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' script: weatheralerts.vb
' 	Revision 	Date		Programmer	Ccomment
'	1.0  		09/11/2011	jfarmer		Initial VB.Net Version
' alertsTrigger - runs the trigger checks
' categoryString - takes the alert categories and puts them in a readable format
' certaintyString - takes the alert certainty and adds descriptive info
' clearAlertsINI - clears all alerts in the ini file
' countyMatch - tales a list of counties and checks to see if any trigger has one of the counties as a trigger
' deviceAlerts - builds the strings for the virtual device
' getUpdateDate - Send an XML file and it finds the last time the file was updated
' importalerts - import the weather alert info from the xml file
' listAppend - appends a value to a delimited list 
' newWeatherAlerts - checks the online alert XML file to see if it has been updated
' severityString - the the alert severity and adds descriptive info
' urgencyString - takes the alert urgency and adds descriptive info
' weatheralert - runs the process to import, save, display and warn for the weather alerts
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Option Strict On
Option Explicit On
Imports VB = Microsoft.VisualBasic
Imports System.IO
Imports System.Xml 
Public Dim debugMode As Boolean = False
Public Dim sINI as String = "weathercom_xml.ini"
Public IName as String = "weatherXML_Alerts"
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Sub Main(Optional ByVal sParm as String = "")
	weatheralert()
End Sub
Sub alertsTrigger(Optional ByVal sParm as String = "")
	Dim aList, tList as Array
	Dim bType, bCat, bUrg, bSev, bCer, bArea as Boolean
	Dim nTrig, nAlert, x, y as Integer
	Dim at as Object
	Dim aTitle, aType, aCat, aUrg, aSev, aCer, aArea as String
	Dim tActive, tName, tEvent, tType, tCat, tUrg, tSev, tCer, tArea as String
	Dim aChk, tChk as String
	debugMode = hs.GetINISetting ("Debug","debugMode","False",sINI)
	Try
		at = hs.CreateStringClass
			nAlert = 0
			Do
				nAlert = nAlert + 1
				at.Add("watitle")
				at.Add(nALert)
				aTitle = hs.GetINISetting("WeatherAlert",at.Value,"",sINI)
				at.Reset
				if len(trim(aTitle)) = 0 Then
					Exit Do
				End if
				at.Add("watype")
				at.Add(nALert)
				aType = hs.GetINISetting("WeatherAlert",at.Value,"",sINI)
				at.Reset
				at.Add("wacategory")
				at.Add(nALert)
				aCat = hs.GetINISetting("WeatherAlert",at.Value,"",sINI)
				at.Reset
				at.Add("waurgency")
				at.Add(nALert)
				aUrg = hs.GetINISetting("WeatherAlert",at.Value,"",sINI)
				at.Reset
				at.Add("waseverity")
				at.Add(nALert)
				aSev = hs.GetINISetting("WeatherAlert",at.Value,"",sINI)
				at.Reset
				at.Add("wacertainty")
				at.Add(nALert)
				aCer = hs.GetINISetting("WeatherAlert",at.Value,"",sINI)
				at.Reset
				at.Add("waarea")
				at.Add(nALert)
				aArea = hs.GetINISetting("WeatherAlert",at.Value,"",sINI)
				at.Reset
				nTrig = 0
				Do
					nTrig = nTrig +	1
					at.Add("triggerActive")
					at.Add(nTrig)
					tActive = hs.GetINISetting("AlertTriggers",at.Value,"",sINI)
					at.Reset
					if tActive = "1" Then
						at.Add("triggerName")
						at.Add(nTrig)
						tName = hs.GetINISetting("AlertTriggers",at.Value,"",sINI)
						at.Reset
						if len(trim(tName)) = 0 Then
							Exit Do
						End if
						at.Add("triggerEvent")
						at.Add(nTrig)
						tEvent = hs.GetINISetting("AlertTriggers",at.Value,"",sINI)
						at.Reset
						at.Add("triggerType")
						at.Add(nTrig)
						tType = hs.GetINISetting("AlertTriggers",at.Value,"",sINI)
						at.Reset
						at.Add("triggerCat")
						at.Add(nTrig)
						tCat = hs.GetINISetting("AlertTriggers",at.Value,"",sINI)
						at.Reset
						at.Add("triggerUrgency")
						at.Add(nTrig)
						tUrg = hs.GetINISetting("AlertTriggers",at.Value,"",sINI)
						at.Reset
						at.Add("triggerSeverity")
						at.Add(nTrig)
						tSev = hs.GetINISetting("AlertTriggers",at.Value,"",sINI)
						at.Reset
						at.Add("triggerCertainty")
						at.Add(nTrig)
						tCer = hs.GetINISetting("AlertTriggers",at.Value,"",sINI)
						at.Reset
						at.Add("triggerArea")
						at.Add(nTrig)
						tArea = hs.GetINISetting("AlertTriggers",at.Value,"",sINI)
						at.Reset
						bType = false
						bCat = false
						bUrg = false
						bSev = false
						bCer = false
						bArea = false
						aList = Split(aType,",")
						tList = split(tType,",")
						for x = 0 to Ubound(aList)
							aChk = aList(x)
							for y = 0 to UBound(tList)
								tChk = tList(y)
								if (lCase(tChk) = lCase(aChk)) OR tChk = "Any" Then
									bType = true
									Exit for
								End if
							Next
							if bType = true Then
								Exit for
							End if
						Next
						if debugMode = true Then
							at.Add("Alert:")
							at.Add(nAlert)
							at.Add(", Trigger:")
							at.Add(nTrig)
							at.Add(", Type=")
							at.Add(bType)
							hs.WriteLog(IName,at.value)
							at.Reset
						End if
						aList = Split(aCat,",")
						tList = split(tCat,",")
						for x = 0 to Ubound(aList)
							aChk = aList(x)
							for y = 0 to UBound(tList)
								tChk = tList(y)
								if (lCase(tChk) = lCase(aChk)) OR tChk = "Any" Then
									bCat = true
									Exit for
								End if
							Next
							if bCat = true Then
								Exit for
							End if
						Next
						if debugMode = true Then
							at.Add("Alert:")
							at.Add(nAlert)
							at.Add(", Trigger:")
							at.Add(nTrig)
							at.Add(", Category=")
							at.Add(bCat)
							hs.WriteLog(IName,at.Value)
							at.Reset
						End if
						aList = Split(aUrg,",")
						tList = split(tUrg,",")
						for x = 0 to Ubound(aList)
							aChk = aList(x)
							for y = 0 to UBound(tList)
								tChk = tList(y)
								if (lCase(tChk) = lCase(aChk)) OR tChk = "Any" Then
									bUrg = true
									Exit for
								End if
							Next
							if bUrg = true Then
								Exit for
							End if
						Next
						if debugMode = true Then
							at.Add("Alert:")
							at.Add(nAlert)
							at.Add(", Trigger:")
							at.Add(nTrig)
							at.Add(", Urgency=")
							at.Add(bUrg)
							hs.WriteLog(IName,at.Value)
							at.Reset
						End if
						aList = Split(aSev,",")
						tList = split(tSev,",")
						for x = 0 to Ubound(aList)
							aChk = aList(x)
							for y = 0 to UBound(tList)
								tChk = tList(y)
								if (lCase(tChk) = lCase(aChk)) OR tChk = "Any" Then
									bSev = true
									Exit for
								End if
							Next
							if bSev = true Then
								Exit for
							End if
						Next
						if debugMode = true Then
							at.Add("Alert:")
							at.Add(nAlert)
							at.Add(", Trigger:")
							at.Add(nTrig)
							at.Add(", Severity=")
							at.Add(bSev)
							hs.WriteLog(IName,at.Value)
							at.Reset
						End if
						aList = Split(aCer,",")
						tList = split(tCer,",")
						for x = 0 to Ubound(aList)
							aChk = aList(x)
							for y = 0 to UBound(tList)
								tChk = tList(y)
								if (lCase(tChk) = lCase(aChk)) OR tChk = "Any" Then
									bCer = true
									Exit for
								End if
							Next
							if bCer = true Then
								Exit for
							End if
						Next
						if debugMode = true Then
							at.Add("Alert:")
							at.Add(nAlert)
							at.Add(", Trigger:")
							at.Add(nTrig)
							at.Add(", Certainty=")
							at.Add(bCer)
							hs.WriteLog(IName,at.Value)
							at.Reset
						End if
						aList = Split(aArea,";")
						tList = split(tArea,",")
						for x = 0 to Ubound(aList)
							aChk = trim(aList(x))
							for y = 0 to UBound(tList)
								tChk = trim(tList(y))
								if (lCase(tChk) = lCase(aChk)) OR tChk = "Any" Then
									bArea = true
									Exit for
								End if
							Next
							if bArea = true Then
								Exit for
							End if
						Next
						if debugMode = true Then
							at.Add("Alert:")
							at.Add(nAlert)
							at.Add(", Trigger:")
							at.Add(nTrig)
							at.Add(", Area=")
							at.Add(bArea)
							hs.WriteLog(IName,at.Value)
							at.Reset
						End if
						if bType = true AND bCat = true AND bUrg = true AND bSev = true AND bCer = true AND bArea = true
							if debugMode = true Then
								at.Add("Alert:")
								at.Add(nAlert)
								at.Add(", Trigger:")
								at.Add(nTrig)
								at.Add(", Event=")
								at.Add(tEvent)
								at.Add(" will run.")
								hs.WriteLog(IName,at.Value)
								at.Reset
							End if
							if len(trim(tEvent)) > 0 Then
								at.Add(nAlert)
								at.Add(":")
								at.Add(nTrig)
								hs.RunEx(tEvent,"Main",at.Value,True)
								at.Reset
							End if
						Else
							if debugMode = true Then
								at.Add("Alert:")
								at.Add(nAlert)
								at.Add(", Trigger:")
								at.Add(nTrig)
								at.Add(", Event=")
								at.Add(tEvent)
								at.Add(" will not run.")
								hs.WriteLog(IName,at.Value)
								at.Reset
							End if
						End if
					End if
				Loop until len(trim(tName)) = 0
			Loop until len(trim(aTitle)) = 0
		at = Nothing
	Catch e as Exception
		hs.WriteLog(IName,"alertsTrigger: " & e.Message)
	End Try
End Sub
Function categoryString(ByVal sCat as String) as String
	Dim aC as Array
	Dim x1 as Integer
	Dim cs as Object
	Dim sC, sCT, rtS as String
	Try
		debugMode = hs.GetINISetting ("Debug","debugMode","False",sINI)
		aC = Split(sCat,",")
		cs = hs.CreateStringClass
			for x1 = 0 to UBound(aC)
				sCt = aC(x1)
				Select Case lCase(trim(sCt))
					Case "geo"
						sC = "Geophysical (inc. landslide)"
					Case "met"
						sC = "Meteorological (inc. flood)"
					Case "safety"
						sC = "Safety (General emergency and public safety)"
					Case "security"
						sC = "Security (Law enforcement, military, homeland and local/private security)"
					Case "rescue"
						sC = "Rescue (Rescue and recovery)"
					Case "fire"
						sC = "Fire (Fire suppression and rescue)"
					Case "health"
						sC = "Health (Medical and public health)"
					Case "env"
						sC = "Environment (Pollution and other environmental)"
					Case "transport"
						sC = "Transport (Public and private transportation)"
					Case "infra"
						sC = "Infrastructure (Utility, telecommunication, other non-transport infrastructure)"
					Case "cbrne"
						sC = "CBRNE (Chemical, Biological, Radiological, Nuclear or High-Yield Explosive threat or attack)"
					Case "other"
						sC = "Other (Other events)"
					Case Else
						sC = sCt
				End Select
				cs.Add(listAppend(cs.Value,sC))
			Next
			rtS = cs.Value
		cs = nothing
	Catch e as Exception
		hs.WriteLog(IName,"categoryString: " & e.Message)
	End Try
	Return rtS
End Function
Function countyMatch(ByVal sCounties as String)
	Dim aCounty, aArea as Array
	Dim x, y , z as Integer
	Dim cm as Object
	Dim sTriggerName, sArea as String
	Try
		debugMode = hs.GetINISetting ("Debug","debugMode","False",sINI)
		cm = hs.CreateStringClass
			aCounty = split(sCounties,";")
			x = 0
			Do 
				x = x + 1
				cm.Add("triggerName")
				cm.Add(x)
				sTriggerName = hs.GetINISetting("AlertTriggers",cm.Value,"",sINI)
				cm.Reset
				if len(trim(sTriggerName)) > 0 Then
					cm.Add("triggerArea")
					cm.Add(x)
					sArea = hs.GetINISetting("AlertTriggers",cm.Value,"",sINI)
					cm.Reset
					aArea = split(sArea,",")
					for y = 0 to UBound(aArea)
						for z = 0 to UBound(aCounty)
							if trim(aArea(y)) = trim(aCounty(z)) OR aArea(y) = "Any" Then
								return true
								Exit Function
							End if
						Next
					Next
				End if
			Loop until len(trim(sTriggerName)) = 0
		cm = Nothing
	Catch e as Exception
		hs.WriteLog(IName,"countyMatch=" & e.Message)
	End Try
	Return false
End Function
Function certaintyString(ByVal sCert as String) as String
	Dim rtS as String
	debugMode = hs.GetINISetting ("Debug","debugMode","False",sINI)
	Try
		Select Case lCase(trim(sCert))
			Case "observed"
				rtS = "Observed (Determined to have occurred or to be ongoing.)"
			Case "very likely"
				rtS = "Very Likely (Likely (p > ~50%))"
			Case "likely"
				rtS = "Likely (Likely (p > ~50%))"
			Case "possible"
				rtS = "Possible (Possible but not likely (p <= ~50%))"
			Case "unlikely"
				rtS = "Unlikely (Not expected to occur (p ~ 0))"
			Case "unknown"
				rtS = "Unknown (Certainty unknown)"
			Case Else
				rtS = sCert
		End Select
	Catch e as Exception
		hs.WriteLog(IName,"certaintyString: " & e.Message)
	End Try
	Return rtS
End Function
Sub clearAlertsINI(ByVal nTotal as String)
	Dim x as Integer
	Dim ia as Object
	debugMode = hs.GetINISetting ("Debug","debugMode","False",sINI)
	ia = hs.CreateStringClass
		For x = 1 to nTotal
			ia.Add("waupdated")
			ia.Add(x)
			hs.SaveINISetting("WeatherAlert",ia.Value,"",sINI)
			ia.Reset
			ia.Add("wapublished")
			ia.Add(x)
			hs.SaveINISetting("WeatherAlert",ia.Value,"",sINI)
			ia.Reset
			ia.Add("watitle")
			ia.Add(x)
			hs.SaveINISetting("WeatherAlert",ia.Value,"",sINI)
			ia.Reset
			ia.Add("walink")
			ia.Add(x)
			hs.SaveINISetting("WeatherAlert",ia.Value,"",sINI)
			ia.Reset
			ia.Add("wasummary")
			ia.Add(x)
			hs.SaveINISetting("WeatherAlert",ia.Value,"",sINI)
			ia.Reset
			ia.Add("waeffective")
			ia.Add(x)
			hs.SaveINISetting("WeatherAlert",ia.Value,"",sINI)
			ia.Reset
			ia.Add("waexpires")
			ia.Add(x)
			hs.SaveINISetting("WeatherAlert",ia.Value,"",sINI)
			ia.Reset
			ia.Add("wastatus")
			ia.Add(x)
			hs.SaveINISetting("WeatherAlert",ia.Value,"",sINI)
			ia.Reset
			ia.Add("watype")
			ia.Add(x)
			hs.SaveINISetting("WeatherAlert",ia.Value,"",sINI)
			ia.Reset
			ia.Add("wacategory")
			ia.Add(x)
			hs.SaveINISetting("WeatherAlert",ia.Value,"",sINI)
			ia.Reset
			ia.Add("waurgency")
			ia.Add(x)
			hs.SaveINISetting("WeatherAlert",ia.Value,"",sINI)
			ia.Reset
			ia.Add("waseverity")
			ia.Add(x)
			hs.SaveINISetting("WeatherAlert",ia.Value,"",sINI)
			ia.Reset
			ia.Add("wacertainty")
			ia.Add(x)
			hs.SaveINISetting("WeatherAlert",ia.Value,"",sINI)
			ia.Reset
			ia.Add("waarea")
			ia.Add(x)
			hs.SaveINISetting("WeatherAlert",ia.Value,"",sINI)
			ia.Reset
		Next
	ia = Nothing
End Sub
Function deviceAlerts(Optional ByVal sParm as String = "")
	Dim x, maxAlerts as Integer
	Dim da as Object
	Dim devCode, devCodeLetter, devCodeNumber, devLink, devAlert, dCertainty as String
	Dim dEffective, dCat, dExpires, dArea, dUrgency, dType, dSummary, dSevere as String
	debugMode = hs.GetINISetting ("Debug","debugMode","False",sINI)
	devCodeLetter = hs.GetINISetting("WeatherAlert","devCodeLetter","",sINI)
	maxAlerts = hs.GetINISetting("WeatherAlert","maxAlerts",10,sINI)
	if len(trim(devCodeLetter)) = 0 OR devCodeLetter = "None" Then
		if debugMode = true Then
			hs.WriteLog(IName,"There are no devices setup for the weather alerts")
		End if
	Else
		da = hs.CreateStringClass
			devCodeNumber = hs.GetINISetting("WeatherAlert","devCodeNumber","",sINI)
			for x = 1 to maxAlerts
				da.Add(devCodeLetter)
				da.Add(devCodeNumber + (x-1))
				devCode = da.Value
				da.Reset
				da.Add("watitle")
				da.Add(x)
				devAlert = hs.GetINISetting("WeatherAlert",da.Value,"",sINI)
				da.Reset
				if  len(trim(devAlert)) > 0 Then
					da.Add("walink")
					da.Add(x)
					devLink = hs.GetINISetting("WeatherAlert",da.Value,"",sINI)
					da.Reset
					da.Add("waeffective")
					da.Add(x)
					dEffective = hs.GetINISetting("WeatherAlert",da.Value,"",sINI)
					da.Reset
					da.Add("waexpires")
					da.Add(x)
					dExpires = hs.GetINISetting("WeatherAlert",da.Value,"",sINI)
					da.Reset
					da.Add("waarea")
					da.Add(x)
					dArea = hs.GetINISetting("WeatherAlert",da.Value,"",sINI)
					da.Reset
					da.Add("waurgency")
					da.Add(x)
					dUrgency = hs.GetINISetting("WeatherAlert",da.Value,"",sINI)
					da.Reset
					da.Add("watype")
					da.Add(x)
					dType = hs.GetINISetting("WeatherAlert",da.Value,"",sINI)
					da.Reset
					da.Add("wacategory")
					da.Add(x)
					dCat = hs.GetINISetting("WeatherAlert",da.Value,"",sINI)
					da.Reset
					da.Add("wasummary")
					da.Add(x)
					dSummary = hs.GetINISetting("WeatherAlert",da.Value,"",sINI)
					da.Reset
					da.Add("waseverity")
					da.Add(x)
					dSevere = hs.GetINISetting("WeatherAlert",da.Value,"",sINI)
					da.Reset
					da.Add("wacertainty")
					da.Add(x)
					dCertainty = hs.GetINISetting("WeatherAlert",da.Value,"",sINI)
					da.Reset
					' Build the device string
					da.Add("<span style=""font-weight:900;")
					if UCase(dType) = "ALERT" Then
						da.Add("color:Red;")
					End if
					da.Add(""">")
					da.Add(UCase(dType))
					da.Add(" For ")
					da.Add(dArea)
					da.Add("</span><br/>")
					da.Add(devAlert)
					da.Add("<br/><br/>")
					da.Add(dSummary)
					da.Add("<br/><br/>Category: ")
					da.Add(categoryString(dcat))
					da.Add("<br/>Certainty: ")
					da.Add(certaintyString(dCertainty))
					da.Add("<br/>Effective: ")
					da.Add(formatDateTime(dEffective,2))
					da.Add(" ")
					da.Add(formatDateTime(dEffective,3))
					da.Add("<br/>Expires: ")
					da.Add(formatDateTime(dExpires,2))
					da.Add(" ")
					da.Add(formatDateTime(dExpires,3))
					da.Add("<br/>Urgency: ")
					da.Add(urgencyString(dUrgency))
					da.Add("<br/>Severity: ")
					da.Add(severityString(dSevere))
					da.Add("<br/><br/>")
					da.Add("<a target=""_New"" href=""")
					da.Add(devLink)
					da.Add(""">More Info</a><br/><br/>")
					hs.SetDeviceString(devCode,da.Value,True)
					hs.SetDeviceStatus(devCode,2)
				Else
					hs.SetDeviceString(devCode,"",True)
					hs.SetDeviceStatus(devCode,3)
				End if
				da.Reset
			Next
		da = Nothing
	End if
End Function
Function getUpdateDate(ByVal chkCont as String) as String
	Dim gu, xmlfile, oNodeList, oNode as Object
	Dim sDate as String = "12/31/2000"
	debugMode = hs.GetINISetting ("Debug","debugMode","False",sINI)
	Try
		xmlfile = CreateObject("Microsoft.XMLDOM")
			xmlfile.async=false
			xmlfile.load(chkCont)
			if xmlfile.parseError.errorcode <> 0 Then
				gu = hs.CreateStringClass
				gu.Add("There was an error with the XML file.  Error Code: ")
				gu.Add(xmlfile.parseError.errorcode)
				hs.WriteLog(IName,gu.Value)
				gu.Reset
			Else
				oNodeList = xmlfile.getElementsByTagName("feed")
					oNode = oNodelist.NextNode
						sDate = oNode.selectSingleNode("updated").Text
					oNode = Nothing
				oNodeList = Nothing
			End if
		xmlfile = Nothing
	Catch e as Exception
		hs.WriteLog(IName,"getUpdateDate: " & e.Message)
		sDate = "12/31/2000"
	End Try
	Return sDate
End Function
Sub importAlerts(Optional ByVal sParm as String = "")
	Dim nLast, x, y as Integer
	Dim ia, xmlfile, oNodeList, oNode, xNode as Object
	Dim sXmlFile, sStatus as String
	debugMode = hs.GetINISetting ("Debug","debugMode","False",sINI)	
	ia = hs.CreateStringClass
		ia.Add(hs.GetAppPath)
		ia.Add("\data\weathercom_xml\weatherAlert.xml")
		sXmlFile = ia.Value
		ia.Reset
		xmlfile = CreateObject("Microsoft.XMLDOM")
			xmlfile.async=false
			xmlfile.load(sXmlFile)
			hs.SaveINISetting ("WeatherAlert","ErrorCode",xmlfile.parseError.errorcode,sINI)
			if xmlfile.parseError.errorcode <> 0 Then
				ia.Add("There was an error with the XML file.  Error Reason: ")
				ia.Add(xmlfile.parseError.reason)
				hs.WriteLog(IName,ia.Value)
				ia.Reset
				hs.SaveINISetting ("WeatherAlert","ErrorCodeReason",xmlfile.parseError.reason,sINI)
				hs.SaveINISetting("WeatherAlert","ErrorCodeTime",trim(Now()),sINI)
			Else
				' Clear Old Info
				if debugMode = true Then
					hs.WriteLog(IName,"Clear old info")
				End if
				nLast = hs.GetINISetting("WeatherAlert","lastLength",1,sINI)
				clearAlertsINI(nLast)
				oNodeList = xmlfile.getElementsByTagName("feed")
					oNode = oNodelist.NextNode
					hs.SaveINISetting ("WeatherAlert","lastUpdate",oNode.selectSingleNode("updated").Text,sINI)
					oNode = Nothing
				oNodeList = xmlfile.getElementsByTagName("entry")
					y = 0
					for x = 1 to oNodeList.Length
						oNode = oNodeList.nextNode
						xNode = oNode.selectSingleNode("cap:status")
						if NOT (xNode Is Nothing) Then
							sStatus = oNode.selectSingleNode("cap:status").text
							if sStatus = "Actual" Then
								if countyMatch(oNode.selectSingleNode("cap:areaDesc").text) = True Then
									y = y + 1
									ia.Add("waupdated")
									ia.Add(y)
									hs.SaveINISetting("WeatherAlert",ia.Value,oNode.selectSingleNode("updated").Text,sINI)
									ia.Reset
									ia.Add("wapublished")
									ia.Add(y)
									hs.SaveINISetting("WeatherAlert",ia.Value,oNode.selectSingleNode("published").text,sINI)
									ia.Reset
									ia.Add("watitle")
									ia.Add(y)
									hs.SaveINISetting("WeatherAlert",ia.Value,oNode.selectSingleNode("title").text,sINI)
									ia.Reset
									ia.Add("walink")
									ia.Add(y)
									hs.SaveINISetting("WeatherAlert",ia.Value,oNode.selectSingleNode("link").getAttribute("href"),sINI)
									ia.Reset
									ia.Add("wasummary")
									ia.Add(y)
									hs.SaveINISetting("WeatherAlert",ia.Value,trim(oNode.selectSingleNode("summary").text),sINI)
									ia.Reset
									ia.Add("waeffective")
									ia.Add(y)
									hs.SaveINISetting("WeatherAlert",ia.Value,oNode.selectSingleNode("cap:effective").text,sINI)
									ia.Reset
									ia.Add("waexpires")
									ia.Add(y)
									hs.SaveINISetting("WeatherAlert",ia.Value,oNode.selectSingleNode("cap:expires").text,sINI)
									ia.Reset
									ia.Add("wastatus")
									ia.Add(y)
									hs.SaveINISetting("WeatherAlert",ia.Value,oNode.selectSingleNode("cap:status").text,sINI)
									ia.Reset
									ia.Add("watype")
									ia.Add(y)
									hs.SaveINISetting("WeatherAlert",ia.Value,oNode.selectSingleNode("cap:msgType").text,sINI)
									ia.Reset
									ia.Add("wacategory")
									ia.Add(y)
									hs.SaveINISetting("WeatherAlert",ia.Value,oNode.selectSingleNode("cap:category").text,sINI)
									ia.Reset
									ia.Add("waurgency")
									ia.Add(y)
									hs.SaveINISetting("WeatherAlert",ia.Value,oNode.selectSingleNode("cap:urgency").text,sINI)
									ia.Reset
									ia.Add("waseverity")
									ia.Add(y)
									hs.SaveINISetting("WeatherAlert",ia.Value,oNode.selectSingleNode("cap:severity").text,sINI)
									ia.Reset
									ia.Add("wacertainty")
									ia.Add(y)
									hs.SaveINISetting("WeatherAlert",ia.Value,oNode.selectSingleNode("cap:certainty").text,sINI)
									ia.Reset
									ia.Add("waarea")
									ia.Add(y)
									hs.SaveINISetting("WeatherAlert",ia.Value,oNode.selectSingleNode("cap:areaDesc").text,sINI)
									ia.Reset
								End if
							End if
						End if
					Next
					hs.SaveINISetting("WeatherAlert","lastLength",y,sINI)
				oNodeList = Nothing								
			End if
		xmlfile = Nothing
	ia = Nothing
End Sub
Function listAppend(ByVal sList As String,ByVal sAdd As String,Optional ByVal sDelimit As String = ",")
	Dim sS as Object
	Dim sT as String = ""
	debugMode = hs.GetINISetting ("Debug","debugMode","False",sINI)
	sS = hs.CreateStringClass
		sS.Add (sList)
		if len(trim(sS.Value)) > 0 Then
			sS.Add (sDelimit)
			sS.Add (sAdd)
		Else
			sS.Add (sAdd)
		End if
		sT = sS.Value
	sS = Nothing
	listAppend = sT
End Function
Function newWeatherAlerts(Optional ByVal sParm as String = "") as Boolean
	Dim newAlerts as Boolean
	Dim dLastUpdate as Date = Now()
	Dim dNewUpdate As Date = Now()
	Dim wa, xf, ft as Object
	Dim sXMLCont, sXMLFile, sXMLFileTemp, sDomain, sURL, sFile2 as String
	debugMode = hs.GetINISetting ("Debug","debugMode","False",sINI)
	Try
		wa = hs.CreateStringClass
			wa.Add(hs.GetAppPath)
			wa.Add("\data\weathercom_xml\weatheralert.xml")
			sXMLFile = wa.Value
			wa.Reset
			if File.Exists(sXMLFile) Then
				if debugMode = true Then
					wa.Add("Checking the existing Weather Alert XML file: ")
					wa.Add(sXMLFile)
					hs.WriteLog(IName,wa.Value)
					wa.Reset
				End if
				dLastUpdate = getUpdateDate(sXMLFile)
				if NOT isDate(dLastUpdate) Then
					wa.Add("The date check returned an invalid date. Date: ")
					wa.Add(dLastUpdate)
					hs.WriteLog(IName,wa.Value)
					wa.Reset
					Exit Function
				End if
				if NOT (dLastUpdate = hs.GetINISetting("WeatherAlert","LastUpdate","",sINI)) Then
					dLastUpdate = hs.GetINISetting("WeatherAlert","LastUpdate","",sINI)
				End if
			End if
			sDomain = hs.GetINISetting("WeatherAlert","host","",sINI)
			sURL = hs.GetINISetting("WeatherAlert","url","",sINI)
			if debugMode = true Then
				wa.Add("Downloading the Weather Alert XML file: ")
				wa.Add(sDomain)
				wa.Add(sURL)
				hs.WriteLog(IName,wa.Value)
				wa.Reset
			End if
			sXMLCont = hs.GetURL(sDomain,sURL,False,80)
			if len(trim(sXMLCont)) > 0 Then
				wa.Add(hs.GetAppPath)
				wa.Add("\data\weathercom_xml\alerttemp.xml")
				sXMLFileTemp = wa.Value
				File.WriteAllText(wa.Value, sXMLCont)
				wa.Reset
				dNewUpdate = getUpdateDate(sXMLFileTemp)
				if isDate(dNewUpdate) AND dateDiff("d",dNewUpdate,"12/31/2000") <> 0 Then
					if debugMode = True Then
						wa.Add("Comparing last: ")
						wa.Add(dLastUpdate)
						wa.Add(" to ")
						wa.Add(dNewUpdate)
						hs.WriteLog(Iname,wa.Value)
						wa.Reset
					End if
					if dLastUpdate = dNewUpdate Then
						if debugMode = True Then
							hs.WriteLog(IName,"No new alerts since last check.")
						End if
						File.Delete(sXMLFileTemp)
						newAlerts = false
					Else
						hs.SaveINISetting("WeatherAlert","lastUpdate",dNewUpdate,sINI)
						File.Copy(sXMLFileTemp,sXMLFile,True)
						sFile2 = hs.GetINISetting ("WeatherAlert","secondsaveloc","",sINI)
						if len(trim(sFile2)) > 0 Then
							wa.Add(hs.GetAPPPath)
							wa.Add("\html\")
							wa.Add(sFile2)
							wa.Add("\weatheralert.xml")
							File.Copy(sXMLFile,wa.Value,True)
							wa.Reset
							if debugMode = true Then
								hs.WriteLog(IName,"Copying the Weather Alert XML file to the second location.")
							End if
						End if
						File.Delete(sXMLFileTemp)
						newAlerts = True
					End if
				Else
					if debugMode = True Then
						hs.WriteLog(IName,"There was a problem with the weatheralert xml file.  Unable to check at this time.")
					End if
					newAlerts = False
				End if
			End if
		wa = Nothing
	Catch e as Exception
		hs.WriteLog(IName,"newWeatherAlerts: " & e.Message)
		newAlerts = False
	End Try
	Return newAlerts
End Function
Function severityString(ByVal sSevere as String) as String
	Dim rtS as String
	Select Case lCase(trim(sSevere))
		Case "extreme"
			rtS = "Extreme (Extraordinary threat to life or property)"
		Case "severe"
			rtS = "Severe (Significant threat to life or property)"
		Case "moderate"
			rtS = "Moderate (Possible threat to life or property)"
		Case "minor"
			rtS = "Minor (Minimal threat to life or property)"
		Case "unknown"
			rtS = "Unknown (Severity unknown)"
		Case Else
			rtS = sSevere
	End Select
	Return rtS
End Function
Function urgencyString(ByVal sUrgent as String) as String
	Dim rtS as String
	Select Case lCase(sUrgent)
		Case "immediate"
			rtS = "Immediate (Responsive action SHOULD be taken immediately)"
		Case "expected"
			rtS ="Expected (Responsive action SHOULD be taken soon - within next hour)"
		Case "future"
			rtS = "Future (Responsive action SHOULD be taken in the near future)"
		Case "past"
			rtS = "Past (Responsive action is no longer required)"
		Case "unknown"
			rtS = "Unknown (Urgency not known)"
		Case Else
			rtS = sUrgent
	End Select
	Return rtS
End Function
Sub weatheralert(Optional ByVal sParm as String="") 
	debugMode = hs.GetINISetting ("Debug","debugMode","False",sINI)
	if newWeatherAlerts = True Then
		if debugMode = true Then
			hs.WriteLog(IName,"There are new alerts.  Continue the process.")
		End if
		' Read the XML file and store the current alerts in the ini file
		importAlerts()
		' Get the ini values and build the virtual device strings
		deviceAlerts()
		' Check the triggers
		alertsTrigger()
	Else 
		if debugMode = true Then
			hs.WriteLog(IName,"Finished checking.  There are no new weather alerts.")
		End if
	End if
End Sub
