﻿'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' script: weathercom_xml_vr.vb
' Revision	Date		Programmer		Comment
' 1.1		09/04/2011	CFGuy			Converted to vb.  Rewrote to use the speak functions to be more consistent. 
' 1.0  		11/24/2011 	Tom Caldwell	Created
'	Instructions for use
'	Create 2 new HomeSeer events with a voice trigger
'	Set this script to run in both events.
' 	weathercom_xml_vr.vb
'	Add the next line to the voice command box in one of the events (Do not include the apostrophe
'	(get|tell|check|whats|what is) (me|the)* (temperature|weather|forecast)(on|for)*(today|tonight|tomorrow|sunday|monday|tuesday|wednesday|thursday|friday|saturday)
' 	Add the next line to the second command box in the other event
'	(get|tell|check|whats|what is) (me|the)* (todays|tonights|tomorrows|sundays|mondays|tuesdays|wednesdays|thursdays|fridays|saturdays) (temperature|weather|forecast)
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Imports VB = Microsoft.VisualBasic
Public Dim debugMode As Boolean = False
Dim sINI as String = "weathercom_xml.ini"
DIM IName as String = "weatherXML_VR"
Dim sVirtualDevice as String
Sub Main(ByVal params As Object)
	Dim aLoop as array
	Dim nLoop as Integer
	Dim vr as Object
	Dim commandStr, srchWord, sType, sDay, sSpeak, sError, sHosts as String
	debugMode = hs.GetINISetting ("Debug","debugMode","False",sINI)
	commandStr = hs.LastVoiceCommandRaw
	if debugMode = True Then
		hs.WriteLog(IName,"VR Command String: " & commandStr)
	End if
	sVirtualDevice = hs.GetINISetting("Settings","lastSpoken","",sINI)		
	sHosts = hs.GetINISetting("Speak","Hosts","",sINI)
	' Find the day part and the type of the VR request
	aLoop = Split(trim(commandStr)," ")
	sType = "unknown"
	sDay = "unknown"
	sSpeak = ""
	for nLoop = 0 to UBound(aLoop)
		srchWord = LCASE(aLoop(nLoop))
		Select Case srchWord
			Case "forecast"
				sType = "forecast"
			Case "temperature"
				sType = "temperature"
			Case "weather"
				sType ="weather"
			Case "today","todays"
				sDay = "today"
			Case "tonight","tonights"
				sDay = "tonight"
			Case "tomorrow","tomorrows"
				sDay = "tomorrow"
			Case "sunday","sundays"
				sDay = "sunday"
			Case "monday","mondays"
				sDay = "monday"
			Case "tuesday","tuesdays"
				sDay = "tuesday"
			Case "wednesday","wednesdays"
				sDay = "wednesday"
			Case "thursday","thursdays"
				sDay = "thursday"
			Case "friday","fridays"
				sDay = "friday"
			Case "saturday","saturdays"
				sDay = "saturday"
		End Select
		hs.waitEvents
	Next
	vr = hs.CreateStringClass
		Select Case lCase(sType)
			Case "forecast","weather"
				sSpeak = hs.RunEx("AZ_weathercom_xml_speak.vb","weatherForecast",sDay,True)
			Case "temperature"
				sSpeak = hs.RunEx("AZ_weathercom_xml_speak.vb","weatherTempDay",sDay,True)
		End Select
		if len(trim(sSpeak)) = 0 Then
			if sType = "unknown" AND sDay = "unknown" Then
				vr.Add("Sorry, maar ik weet niet om welke informatie u vraagt.  ")
			Elseif sType = "unknown" AND sDay <> "unknown" Then
				vr.Add("Sorry, maar ik begrijp niet om welke informatie u vraagt voor ")
				vr.Add(sDay)
				vr.Add(".  ")
			Elseif sType <> "unknown" AND sDay = "unknown" Then
				vr.Add("Sorry, maar ik begrijp dat u informatie wilt over  ")
				vr.Add(sType)
				'vr.Add(" information.  ")
			Elseif sType <> "unknown" AND sDay <> "unknown" Then
				vr.Add("Sorry, maar er is op het moment geen ")
				vr.Add(sType)
				vr.Add(" informatie over ")
				vr.Add(sDay)
				vr.Add(".  ")
			End if
			vr.Add("Probeer het nog een keer.  ")
			hs.WriteLog(IName,vr.Value)
			vr.Add(hs.GetINISetting("speak","speakFirst","",sINI))
			hs.speak(vr.Value,false,sHosts)
			vr.Reset
		Else
			if debugMode = true Then
				vr.Add("Speak: ")
				vr.Add(sSpeak)
				hs.writeLog(IName,vr.Value)
				vr.Reset
			End if
			if len(trim(sVirtualDevice)) > 0 Then
				hs.SetDeviceString(sVirtualDevice, sSpeak, true)
			End if
			vr.Add(hs.GetINISetting("speak","speakFirst","",sINI))
			vr.Add(sSpeak)
			hs.speak(vr.Value,false,sHosts)
			vr.Reset
		End if
	vr = Nothing
End Sub

