<% 
	Option Explicit
	Dim sLev, sHeader
	function weathertools(sHeading)
		Dim fs
		Dim sINI, intPreFillTemp, intPreFillDewP, intPreFillHumP, intPreFillWind, intWind, intWinda
		Dim pos1
		sINI = "weathercom_xml.ini"
		intPreFillTemp = hs.GetINISetting ("WeatherInfo","CurrentTemp","",sINI)
		intPreFillDewP = hs.GetINISetting ("WeatherInfo","Dewpoint","",sINI)
		intPreFillHumP = hs.GetINISetting ("WeatherInfo","Humidity","",sINI)
		intPreFillWind = hs.GetINISetting ("WeatherInfo","Wind","",sINI)
		if intPreFillWind <> "Calm" Then
			intWind = strReverse(intPreFillWind)
			pos1 = InStr(intWind," ")
			intWinda = Right(intPreFillWind,pos1)
			intPreFillWind = trim(intWinda)
		End if
		Set fs = hs.CreateStringClass
			fs.Add "<script language=""javascript"">"
			fs.Add vbNewLine
			fs.Add "<!-- Script is by Ron Murphy. -->"
			fs.Add vbNewLine
			fs.Add vbNewLine
		
			fs.Add "function ftoc(form){"
			fs.Add vbNewLine
			fs.Add "var tempff = form.tempf.value;"
			fs.Add vbNewLine
			fs.Add "form.Celsius.value = (tempff - 32) * .556;"
			fs.Add vbNewLine
			fs.Add "}"
			fs.Add vbNewLine
			fs.Add vbNewLine
	
			fs.Add "function ctof(form){"
			fs.Add vbNewLine
			fs.Add "var tempcc = form.tempc.value;"
			fs.Add vbNewLine
			fs.Add "form.Fahrenheit.value = 1.80*tempcc + 32.0;"
			fs.Add vbNewLine
			fs.Add "}"
			fs.Add vbNewLine
			fs.Add vbNewLine
	
			fs.Add "function windchill1(form)"
			fs.Add vbNewLine
			fs.Add "{ var untemp = form.intemp.value;"
			fs.Add vbNewLine
			fs.Add "var wnd = form.mph.value;"
			fs.Add vbNewLine
			fs.Add "if (wnd < 4)"
			fs.Add vbNewLine
			fs.Add "{ alert(""Invalid wind speed. Wind speed must be 4 mph or greater. Click on reset and try again!""); }"
			fs.Add vbNewLine
			fs.Add "else if (wnd > 60)"
			fs.Add vbNewLine
			fs.Add "{ alert (""Wind speed over 60 mph has little additional chilling effect. Click on reset and try again!""); }"
			fs.Add vbNewLine
			fs.Add "else"
			fs.Add vbNewLine
			fs.Add "{ var wc = 0.0817*(3.71*Math.sqrt(form.mph.value)+5.81 - 0.25*form.mph.value)*(form.intemp.value-91.4) + 91.4;"
			fs.Add vbNewLine
			fs.Add "form.windchill.value=Math.round(wc); }"
			fs.Add vbNewLine
			fs.Add " }"
			fs.Add vbNewLine
			fs.Add vbNewLine
	
			fs.Add "function RH(form)"
			fs.Add vbNewLine
			fs.Add "{"
			fs.Add vbNewLine
			fs.Add "var tc = (form.airtemp.value - 32) * .556;"
			fs.Add vbNewLine
			fs.Add "var tdc = (form.dewpointtemp.value -32)* .556;"
			fs.Add vbNewLine
			fs.Add "if (tc < tdc)"
			fs.Add vbNewLine
			fs.Add "{ alert(""Your air temperature cannot be higher than the dew point temperature.  Click on reset and try again!""); }"
			fs.Add vbNewLine
			fs.Add "else"
			fs.Add vbNewLine
			fs.Add "{"
			fs.Add vbNewLine
			fs.Add "var stuff = (112-(0.1*tc)+tdc)/(112+(0.9*tc));"
			fs.Add vbNewLine
			fs.Add "form.relativeh.value = Math.round(100.0*(Math.pow(stuff,8)));"
			fs.Add vbNewLine
			fs.Add "}"
			fs.Add vbNewLine
			fs.Add "}"
			fs.Add vbNewLine
			fs.Add vbNewLine
	
			fs.Add "function heat1(form)"
			fs.Add vbNewLine
			fs.Add "{ var temptest = form.tempair.value;"
			fs.Add vbNewLine
			fs.Add "var RH = form.RHumidity.value;"
			fs.Add vbNewLine
			fs.Add "if(RH < 0 || RH > 100)"
			fs.Add vbNewLine
			fs.Add "{ alert(""Invalid entry. RH ranges from 0 to 100. Click on reset and try again!""); }"
			fs.Add vbNewLine
			fs.Add "if(temptest < 80)"
			fs.Add vbNewLine
			fs.Add "{ alert(""Temperatures below 80 have little effect on heat index. Click on reset and try again!""); }"
			fs.Add vbNewLine
			fs.Add "else"
			fs.Add vbNewLine
			fs.Add "{ var hi = -42.379+2.04901523*form.tempair.value+10.14333127*form.RHumidity.value-0.22475541*form.tempair.value*form.RHumidity.value-6.83783*(Math.pow(10, -3))*(Math.pow(form.tempair.value, 2))-5.481717*(Math.pow(10, -2))*(Math.pow(form.RHumidity.value, 2))+1.22874*(Math.pow(10, -3))*(Math.pow(form.tempair.value, 2))*form.RHumidity.value+8.5282*(Math.pow(10, -4))*form.tempair.value*(Math.pow(form.RHumidity.value, 2))-1.99*(Math.pow(10, -6))*(Math.pow(form.tempair.value, 2))*(Math.pow(form.RHumidity.value,2));"
			fs.Add vbNewLine
			fs.Add "form.heatindex.value = Math.round(hi);"
			fs.Add vbNewLine
			fs.Add " }"
			fs.Add vbNewLine
			fs.Add " }"
			fs.Add vbNewLine
			fs.Add vbNewLine
		
			fs.Add "function clear(form)"
			fs.Add vbNewLine
			fs.Add "{ // set it all to null"
			fs.Add vbNewLine
			fs.Add "form.mileage.value = """";"
			fs.Add vbNewLine
			fs.Add "form.airtemp.value = """";"
			fs.Add vbNewLine
			fs.Add "form.dewpointtemp.value = """";"
			fs.Add vbNewLine
			fs.Add "form.relativeh.value = """";"
			fs.Add vbNewLine
			fs.Add "}"
			fs.Add vbNewLine
			fs.Add vbNewLine
			fs.Add "</script>"
			fs.Add "<table><form><tr><td class=""tableheader"" colspan=""7"">"
			fs.Add sHeading
			fs.Add "</td></tr>"
			fs.Add "<tr><td class=""tablecolumn"" colspan=7>Temperature Conversion</td></tr>"
			fs.Add "<tr class=""tablerowodd""><td></td>	<td colspan=""2"">Fahrenheit ( &deg;F )</td><td><INPUT TYPE=""text"" value="""
			fs.Add intPreFillTemp
			fs.Add """ NAME=""tempf"" SIZE=6></td><td><INPUT TYPE=""button"" class=""formbutton"" VALUE=""   Convert to Celsius   "" Onclick=""ftoc(this.form)""></td>"
			fs.Add "<td><INPUT TYPE=""text"" NAME=""Celsius"" SIZE=6></td><td>&nbsp;</td></tr>"
			fs.Add "<tr class=""tableroweven""><td></td><td colspan=""2"">Celsius ( &deg;C  )</td><td><INPUT TYPE=""text"" NAME=""tempc"" SIZE=6></td>"
			fs.Add "<td><INPUT TYPE=""button"" class=""formbutton"" VALUE=""Convert to Fahrenheit"" Onclick=""ctof(this.form)""></td><td><INPUT TYPE=""text"" NAME=""Fahrenheit"" SIZE=6></td>"
			fs.Add "<td><INPUT TYPE=""reset"" class=""formbutton"" VALUE="" Reset "" OnClick=""clear(this.form)""></td></tr>"
			fs.Add "<tr><td class=""tablerowodd"" colspan=7>Enter a number then click on the appropriate button to see the result.</td></tr>"
			fs.Add "<tr><td class=""tablecolumn"" colspan=7>Windchill Calculation</td></tr>"
			fs.Add "<tr class=""tableroweven""><td> T<sub>air</sub></td><td><INPUT TYPE=""text"" value="""
			fs.Add intPreFillTemp
			fs.Add """ NAME=""intemp"" SIZE=6></td><td> mph</td><td><INPUT TYPE=""text"" value="""
			fs.Add intPreFillWind
			fs.Add """ NAME=""mph"" SIZE=6></td><td><INPUT TYPE=""button"" class=""formbutton"" VALUE="" Calculate WC"" Onclick=""windchill1(this.form)""></td>"
			fs.Add "<td><INPUT TYPE=""text"" NAME=""windchill"" SIZE=6></td><td><INPUT TYPE=""reset"" class=""formbutton"" VALUE="" Reset "" OnClick=""clear(this.form)""></td></tr>"
			fs.Add "<tr><td class=""tablerowodd"" colspan=7>Enter in the air temperature ( T<sub>air</sub> ) in degrees Fahrenheit and wind speed in mph, then click on the Calculate WC to compute the windchill ( WC ).</td></tr>"
			fs.Add "<tr><td class=""tablecolumn"" colspan=7>Relative Humidity Calculation</td></tr>"
			fs.Add "<tr class=""tableroweven""><td> T<sub>air</sub></td><td><INPUT TYPE=""text"" value="""
			fs.Add intPreFillTemp
			fs.Add """ NAME=""airtemp"" SIZE=6></td><td> T<sub>dp</sub></td><td><INPUT TYPE=""text"" value="""
			fs.Add intPreFillDewP
			fs.Add """ NAME=""dewpointtemp"" SIZE=6></td><td><INPUT TYPE=""button"" class=""formbutton"" VALUE="" Calculate RH"" Onclick=""RH(this.form)""></td>"
			fs.Add "<td><INPUT TYPE=""text"" NAME=""relativeh"" SIZE=6></td><td><INPUT TYPE=""reset"" class=""formbutton"" VALUE="" Reset "" OnClick=""clear(this.form)""></td></tr>"
			fs.Add "<tr><td class=""tablerowodd"" colspan=7>Enter in the air temperature ( T<sub>air</sub> ) and dew point temperature ( T<sub>dp</sub>) in degrees Fahrenheit ( <sup>o</sup>F ) then click on the Calculate RH to compute the relative humidity ( RH )</td></tr>"
			fs.Add "<tr><td class=""tablecolumn"" colspan=7>Heat Index Calculation</td></tr>"
			fs.Add "<tr class=""tableroweven""><td> T<sub>air</sub></td><td><INPUT TYPE=""text"" value="""
			fs.Add intPreFillTemp
			fs.Add """ NAME=""tempair"" SIZE=6></td><td> RH</td><td><INPUT TYPE=""text"" value="""
			fs.Add intPreFillHumP
			fs.Add """ NAME=""RHumidity"" SIZE=6></td><td><INPUT TYPE=""button"" class=""formbutton"" VALUE="" Calculate HI"" Onclick=""heat1(this.form)""></td><td><INPUT TYPE=""text"" NAME=""heatindex"" SIZE=6></td>"
			fs.Add "<td><INPUT TYPE=""reset"" class=""formbutton"" VALUE="" Reset "" OnClick=""clear(this.form)""></td></tr>"
			fs.Add "<tr><td class=""tablerowodd"" colspan=7>Enter in the air temperature ( T<sub>air</sub> ) in degrees Fahrenheit and relative humidity ( RH ) in percent, then click on the Calculate HI to compute the heat index ( HI ).</td></tr>"
			fs.Add "</form></table>"
			weathertools = fs.Value
		Set fs = Nothing
	End function
	sHeader = hs.RunEx("AZ_weatherXML_web.vb","webPageHeader","weathertools.asp",true)
	Response.Write  hs.GetPageHeader(sHeader,"","",False,False,False,False,False)
	Response.Write hs.RunEx("AZ_weatherXML_web.vb","weatherPageLinks",hs.WEBLoggedInUser,True)
	sLev = hs.RunEx("AZ_weatherXML_web.vb","checkPageAccess","weathertools.asp",true)
	if sLev = "none" Then
		Response.Write hs.RunEx("AZ_weatherXML_web.vb","pageNotActive","",true)
	Elseif sLev = "all" OR (sLev = "admin" AND hs.RunEx("AZ_weatherXML_web.vb","userPermissions",hs.WebLoggedInUser, true) = 1) Then 
		Response.Write weathertools(sHeader)
	Else
		Response.Write hs.RunEx("AZ_weatherXML_web.vb","pageNoAccess","",true)
	End if
	Response.Write hs.RunEx("AZ_weatherXML_web.vb","weatherPageLinks",hs.WEBLoggedInUser,True)
	Response.Write hs.GetPageFooter(false) 
%>
